c     Variables:
c
c  
c            h =  mesh size
c            nd = number of directions(=18)(i.e. F,E,N,B,W,S)
c                                           para u_x, u_y, u_z
c
c     For each small cube [(j-1)h,jh]x[(k-1)h,kh],[(l-1)h,lh](=cube(j,k,l)),

c     (j=1,..,nx, k=1,...,ny, l=1,...,nz) 
c      we will solve the following linear system:
c      
c            ma * u = b (ma=18x18 matrix, u=unknown vector of 18 elements,
c                        b=right hand side vector of 18 elements)
c
c      Son 18 eltos porque hay 3 componentes con 6 direcciones c/u
c
c  units used :  meters, gr, msec ( so frequency is measured in kHz)
        implicit none
csp2 ------------------------------------------------------
	include 'mpif.h'
csp2 ------------------------------------------------------
        real*8 den,num,denb,denr,numb,numr
       include 'commons.aniso'
        real*8 t0,timer,pe,pf,pn,pb,pw,ps,xmax
        integer ii,n,kk,ik,ll
       integer iw,ian
       real*8 p11,p22,p33,p44,p55,p66,p12,p13,p23
       real*8 p11i,p22i,p33i,p44i,p55i,p66i,p12i,p13i,p23i
csp2 ------------------------------------------------------
       double precision suml(2), swork(2)
       complex*16 sendvec(1:6*(myz+2)*mnx),recvec(1:6*(myz+2)*mnx)
       complex*16 aim
       integer mpierr,nprocs,nmax,nsize
csp2 ------------------------------------------------------
	integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------
	call MPI_INIT(mpierr)
        if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (1)'
           stop
         endif 
           	
	call MPI_COMM_SIZE(MPI_COMM_WORLD,nprocs,mpierr)
	   if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (2)'
           stop
         endif
csp2-------------------------------------------------------
       open(unit=5,file='inp.aniso',status='old')
       open(unit=6,file='out.aniso',status='unknown')
c
       OPEN(UNIT=10,FILE='p11.freq',STATUS='UNKNOWN')
       OPEN(UNIT=11,FILE='p22.freq',STATUS='UNKNOWN')
       OPEN(UNIT=12,FILE='p33.freq',STATUS='UNKNOWN')
       OPEN(UNIT=13,FILE='p44.freq',STATUS='UNKNOWN')
       OPEN(UNIT=14,FILE='p55.freq',STATUS='UNKNOWN')
       OPEN(UNIT=15,FILE='p66.freq',STATUS='UNKNOWN')
c       OPEN(UNIT=16,FILE='p12.freq',STATUS='UNKNOWN')
       OPEN(UNIT=17,FILE='p13.freq',STATUS='UNKNOWN')
       OPEN(UNIT=18,FILE='p23.freq',STATUS='UNKNOWN')

       pi=dabs(4.d0*datan(1.d0))
       twopi=2.d0*pi  
       aim=dcmplx(0.d0,1.d0)             
c 
c       serial code
       t0 = timer()
c       blockid = 0
csp2 ------------------------------------------------------
c
c        ANISOTROPIA VTI con fracturas = ortorrombico
c        ADAPTADO PARA VTI CON EJE DE SIMETRIA VERTICAL
c        LAS UNIDADES SON kHz y milisegundo
c
csp2--------------------------------------------------------

	call MPI_COMM_RANK(MPI_COMM_WORLD,blockid,mpierr)
	
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (3)'
           stop
         endif	
csp2--------------------------------------------------------
       call readata
c      if(blockid.eq.ncontrol) then
c       stop 11223
c      endif
csp2--------------------------------------------------------
      nmax = ny
      if(nmax.lt.nz) nmax = nz
      nsize = (nmax+2)*6*nx
csp2--------------------------------------------------------
       ib=18
     	       
       vblockid(1) = mod(blockid,nsy)
       vblockid(2) = blockid/nsy
                     
       call subtype

       call setdelta
       
       call inguess
c
c     nodos para stripes (ngnod(nx,18))
c
       call nodes
c
c    sets constants for solvu 
c 
c      aux0=1.d0*h/1890.d0
c      aux1=1110.d0
c      aux3=2220.d0
c      aux6=3780.d0
c      aux7=30.d0
c      aux8=1890.d0
c      aux9=6330.d0
c      aux12=2550.d0
c      au1=85.d0
c      au2=74.d0
c      au3=211.d0
c      au4=63.d0
c      au6=37.d0
c      au7=148.d0
c      au8=248.d0
c      au9=122.d0
c      au10=126.d0
c
      do jw = jw2,jw1,-1
       fjw=jw
       fjw=fjw-1.d0+.5d0
       fr=fjw*delf
      read(10,*) fre,p11,p11i
      read(11,*) fre,p22,p22i
      read(12,*) fre,p33,p33i    
      read(13,*) fre,p44,p44i
      read(14,*) fre,p55,p55i    
      read(15,*) fre,p66,p66i
c      read(16,*) fre,p12,p12i    
      read(17,*) fre,p13,p13i
      read(18,*) fre,p23,p23i
c
c        c11mat(1,jw) = dcmplx(p11*1.d-3,p11i*1.d-3)
c        c22mat(1,jw) = dcmplx(p22*1.d-3,p22i*1.d-3)
c        c33mat(1,jw) = dcmplx(p33*1.d-3,p33i*1.d-3)
c        c44mat(1,jw) = dcmplx(p44*1.d-3,p44i*1.d-3)
c        c55mat(1,jw) = dcmplx(p55*1.d-3,p55i*1.d-3)
c        c66mat(1,jw) = dcmplx(p66*1.d-3,p66i*1.d-3)
c        c12mat(1,jw) = dcmplx(p12*1.d-3,p12i*1.d-3)
c        c13mat(1,jw) = dcmplx(p13*1.d-3,p13i*1.d-3)
c        c23mat(1,jw) = dcmplx(p23*1.d-3,p23i*1.d-3)
c
c  VTI CON EJE DE SIMETRIA HORIZONTAL
c
        c11mat(1,jw) = dcmplx(p11*1.d-3,p11i*1.d-3)
        c22mat(1,jw) = dcmplx(p11*1.d-3,p11i*1.d-3)
        c33mat(1,jw) = dcmplx(p33*1.d-3,p33i*1.d-3)
        c44mat(1,jw) = dcmplx(p44*1.d-3,p44i*1.d-3)
        c55mat(1,jw) = dcmplx(p44*1.d-3,p44i*1.d-3)
        c66mat(1,jw) = dcmplx(p66*1.d-3,p66i*1.d-3)
        c12mat(1,jw) = c11mat(1,jw) - 2.d0 * c66mat(1,jw)
        c13mat(1,jw) = dcmplx(p13*1.d-3,p13i*1.d-3)
        c23mat(1,jw) = dcmplx(p13*1.d-3,p13i*1.d-3)

        c14mat(1,jw) = dcmplx(0.d0,0.d0)
        c15mat(1,jw) = dcmplx(0.d0,0.d0)
        c16mat(1,jw) = dcmplx(0.d0,0.d0)
        c24mat(1,jw) = dcmplx(0.d0,0.d0)
        c25mat(1,jw) = dcmplx(0.d0,0.d0)
        c26mat(1,jw) = dcmplx(0.d0,0.d0)
        c34mat(1,jw) = dcmplx(0.d0,0.d0)
        c35mat(1,jw) = dcmplx(0.d0,0.d0)
        c36mat(1,jw) = dcmplx(0.d0,0.d0)
        c45mat(1,jw) = dcmplx(0.d0,0.d0)
        c46mat(1,jw) = dcmplx(0.d0,0.d0)
        c56mat(1,jw) = dcmplx(0.d0,0.d0)
      enddo
c
                 jw1 = jw2 
c                 jw2 = iwsnap(1)
c                 jw2 = iwsnap(1) + 2
c  Si comento lo de arriba queda variable la frec

      if(blockid.eq.ncontrol) then
               write(6,2345)jw1,jw2
2345        format(/1x,' jw1 , jw2  in main = ',i5,4x,i5)
      endif

            do 3000 jw = jw2,jw1,-1
       fjw=jw
       fjw=fjw-1.d0+.5d0
       fr=fjw*delf
       omega=fr*twopi       
      if(blockid.eq.ncontrol) then
            write(6,128)jw,fr
128        format(/1x,' frequency number ',i5,' frequency : ',e20.8)  
      endif 

c   fills  coefficient matrices rho,vp,vs1,vs2 (frequency dependent)
       
c       call coef
ccc
      if(blockid.eq.ncontrol) then
       write(6,*)'V_qP(0) = ',
     #            1.d0/dreal(1.d0/cdsqrt(c33mat(1,jw)/rhomat(1)))
      write(6,*)'p_33 - density = ',c33mat(1,jw),rhomat(1)
       write(6,*)'V_qP(90)_x = ',
     #            1.d0/dreal(1.d0/cdsqrt(c11mat(1,jw)/rhomat(1)))
       write(6,*)'V_qP(90)_y = ',
     #            1.d0/dreal(1.d0/cdsqrt(c22mat(1,jw)/rhomat(1)))
       write(6,*)'V_qS(0)_x = ',
     #            1.d0/dreal(1.d0/cdsqrt(c55mat(1,jw)/rhomat(1)))  
       write(6,*)'V_qS(0)_y = ',
     #            1.d0/dreal(1.d0/cdsqrt(c44mat(1,jw)/rhomat(1)))      
      endif      
ccc
c
       do ll=1,nz
         do kk=1,ny
             call lhsLU(ll,kk)
         enddo
       enddo
c
c     start iteration
c
         if(jw.le.jwlow) imax = maxlow
       do 3 iter=1,imax 
csp2--------------------------------------------------------
        call setbuf(sendvec,recvec,nsize)
csp2--------------------------------------------------------
c
c     loop over the BLACK strips
c     
            call solvub
            call uplagb
            call relaxb

c       if (iter.gt.1.and.mod(iter,20).eq.0) then
       if (iter.gt.1.and.mod(iter,1).eq.0) then
            call relerror_b(numb,denb)
       endif
            call shift_b

csp2--------------------------------------------------------
        call setbuf(sendvec,recvec,nsize)
csp2--------------------------------------------------------
c
c      loop over the RED strips
c
            call solvur      	  	  
            call uplagr
            call relaxr
           
c       if (iter.gt.1.and.mod(iter,20).eq.0) then
       if (iter.gt.1.and.mod(iter,20).eq.0) then
            call relerror_r(numr,denr)
       endif
            call shift_r
	    
      if(iter.eq.1) error=1.d0
c      if(iter.gt.1.and.mod(iter,20).eq.0) then
      if(iter.gt.1.and.mod(iter,20).eq.0) then
            num=numb+numr
            den=denb+denr
csp2--------------------------------------------------------
            suml(1) = num
            suml(2) = den

       call MPI_ALLREDUCE(suml,swork,2,MPI_DOUBLE_PRECISION,
     &                       MPI_SUM,MPI_COMM_WORLD,mpierr)

            num = swork(1)
            den = swork(2)
	       if(den.lt.1.d-6) den = 1.d0
csp2--------------------------------------------------------
            error=2.d0*sqrt(num/den)
      endif

c      if(blockid.eq.ncontrol.and.mod(iter,100).eq.0) then
      if(blockid.eq.ncontrol.and.mod(iter,20).eq.0) then
        write(6,99)iter,error
99       format(/1x,' iter. # ',i5,' rel. error ',g20.7)	
c        write(7,98)iter,error
98       format(i5,e15.5)
      endif      		
        if(error.le.toler) goto 4
        
3       continue

c     if iter=imax, call 'failoutput'

        iter=imax 
        call failoutput
        goto 5

c     if i<imax and error<toler, print the error and number of 
c     iterations

  4    continue
      if(blockid.eq.ncontrol) then
      write(6,10)iter,error
   10 format(/' CONVERG. achieved in iteration # = ',i5,',',3x,
     *          ' relative error =',e12.5)
c            write(7,3727)jw,iter
3727        format(2i6)
                endif
c
c      checks if has to write a snapshot for the current frequency

c       do iw=1,nwsnap
c       if(jw.eq.iwsnap(iw)) then
c       call output(iw)
c       endif
c       enddo

c        call finvpic2_planos
        call finvpic2_cubos

         do ii=1,nrec
        if(blockid.eq.irecid(ii)) then
       rec1w(ii,jw)= (u1f(j1(ii),k1(ii),l1(ii)) +
     *                u1e(j1(ii),k1(ii),l1(ii)) +
     *                u1n(j1(ii),k1(ii),l1(ii)) +
     *                u1b(j1(ii),k1(ii),l1(ii)) +
     *                u1w(j1(ii),k1(ii),l1(ii)) +
     *                u1s(j1(ii),k1(ii),l1(ii)))/6.d0   
c para obtener velocidades
      if(cdabs(rec1w(ii,jw)).lt.1.e-14)rec1w(ii,jw)=dcmplx(0.d0,0.d0)  
       rec1w(ii,jw)=aim*omega* rec1w(ii,jw)
   
       rec2w(ii,jw)= (u2f(j1(ii),k1(ii),l1(ii)) +
     *                u2e(j1(ii),k1(ii),l1(ii)) +
     *                u2n(j1(ii),k1(ii),l1(ii)) +
     *                u2b(j1(ii),k1(ii),l1(ii)) +
     *                u2w(j1(ii),k1(ii),l1(ii)) +
     *                u2s(j1(ii),k1(ii),l1(ii)))/6.d0     
c para obtener velocidades
      if(cdabs(rec2w(ii,jw)).lt.1.e-14)rec2w(ii,jw)=dcmplx(0.d0,0.d0)
       rec2w(ii,jw)=aim*omega* rec2w(ii,jw)
    
       rec3w(ii,jw)= (u3f(j1(ii),k1(ii),l1(ii)) +
     *                u3e(j1(ii),k1(ii),l1(ii)) +
     *                u3n(j1(ii),k1(ii),l1(ii)) +
     *                u3b(j1(ii),k1(ii),l1(ii)) +
     *                u3w(j1(ii),k1(ii),l1(ii)) +
     *                u3s(j1(ii),k1(ii),l1(ii)))/6.d0
c para obtener velocidades
      if(cdabs(rec3w(ii,jw)).lt.1.e-14)rec3w(ii,jw)=dcmplx(0.d0,0.d0)
       rec3w(ii,jw)=aim*omega* rec3w(ii,jw)
        endif
          enddo
c  Guarda los receptores para c/frecuencia
c  Hay 3 componentes de cada receptor (rec1w,rec2w,rec3w)
c  Porque la uf esta con j1 -1 y las demas no???

  5    continue
3000        continue
c 
c      call tgprint_planos
      call tgprint_cubos

c       call outime
c
c  Esto solo con la comp 1 del receptor (paso de frec a tiempo)
c
       do ii=1,nrec
        if(blockid.eq.irecid(ii)) then
       do n=jw1,jw2
       fx(n)=rec1w(ii,n)
c comentar linea siguiente si se guarda la velocidad (ya esta hecho)
c       if(cdabs(fx(n)).lt.1.e-14) fx(n) = dcmplx(0.d0,0.d0)
       enddo
       call finvu2
       write(599+ii,3401)((n-1)*dt,tx(n),n=1,nt)
        endif
       enddo
c Normalizado
c        xmax = 0.d0
c        do n=1,nt
c        if(dabs(tx(n)).gt.xmax) xmax = dabs(tx(n))
c        enddo
c
c        do n=1,nt
c        tx(n) = tx(n)/xmax
c         if(dabs(tx(n)).lt.1.e-14) tx(n) = 0.d0
c        enddo
c       write(9+ii,3401)((n-1)*dt,tx(n),n=1,nt)
c        endif
c       enddo
c  Esto solo con la comp 2 del receptor (paso de frec a tiempo)
c
       do ii=1,nrec
        if(blockid.eq.irecid(ii)) then
       do n=jw1,jw2
       fx(n)=rec2w(ii,n)
c comentar linea siguiente si se guarda la velocidad (ya esta hecho)
c       if(cdabs(fx(n)).lt.1.e-14) fx(n) = dcmplx(0.d0,0.d0)
       enddo
       call finvu2
       write(699+ii,3401)((n-1)*dt,tx(n),n=1,nt)
        endif
       enddo
c  Esto solo con la comp 3 del receptor (paso de frec a tiempo)
c
       do ii=1,nrec
        if(blockid.eq.irecid(ii)) then
       do n=jw1,jw2
       fx(n)=rec3w(ii,n)
c comentar linea siguiente si se guarda la velocidad (ya esta hecho)
c       if(cdabs(fx(n)).lt.1.e-14) fx(n) = dcmplx(0.d0,0.d0)
       enddo
       call finvu2
       write(799+ii,3401)((n-1)*dt,tx(n),n=1,nt)
        endif
       enddo
c Normalizado
c        xmax = 0.d0
c        do n=1,nt
c        if(dabs(tx(n)).gt.xmax) xmax = dabs(tx(n))
c        enddo
c
c        do n=1,nt
c        tx(n) = tx(n)/xmax
c         if(dabs(tx(n)).lt.1.e-14) tx(n) = 0.d0
c        enddo
c       write(29+ii,3401)((n-1)*dt,tx(n),n=1,nt)
c        endif
c       enddo
3401   format(2g15.4)
csp2----------------------------------------------------------------
       if (blockid.eq.ncontrol) then
         write(6,2356)timer()-t0
2356     format(/1x,'tiempo-t0=',g20.8)
       endif 
csp2----------------------------------------------------------------
	call MPI_FINALIZE(mpierr)
        if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (6)'
           stop
         endif		
csp2-----------------------------------------------------------------
       if (blockid.eq.ncontrol) then
         write(6,2357)timer()
2357     format(/1x,'tiempo=',g20.8)
       endif

       stop
       end 
*********************************************************************
       real*8 function timer()
       implicit none
       real*4 etime,ust(2),time,time0
       data time0/0.0/

       time = etime(ust)
       timer = time - time0
       time0 = time

       return
       end
c
c  The function below should be used with the IBM's 
c
c      real*8 function timer()
c      integer*4 mclock,time,time0
c      data time0/0/

c      time = mclock()
c      timer = (time-time0)/100.
c      time0 = time

c      return
c      end
*********************************************************************
      subroutine readata
       implicit none
       include 'commons.aniso'
       integer npw,ixi,ixf,iyi,iyf,izi,izf,j,k,l
       integer ks,ls,ii,i,numat
       integer souvid1,souvid2,n,x,y,z
       integer recid1,recid2,kre,lre,iry(mnrec),irz(mnrec)
       real*8 wavel,speed(mnmat),tt0,ff
       real*8 alfa,w0,tt,ysourbl,zsourbl,ysloc,zsloc,fnpf
       real*8 yrecbl,zrecbl,yrloc,zrloc,secfac,fact
       real*8 calcw,psi,width,ts,totpul,aux,w1,xmax,fif3,fif4
       real*8 xi,yi,zi,xf,yf,zf
    

c  nsy = # processors in the y-direction
c  nsz = # processors in the z-direction
170    format(i5)
150    format(e20.8)
       read(5,170)nsy
       read(5,170)nsz
       read(5,170)ncontrol
c   Esto era para el paralelo!!(no borrar)
c  sets domain size in m
        read(5,150) xsize
        read(5,150) ysize
        read(5,150) zsize
        read(5,170) nx
        read(5,170) ngy
        read(5,170) ngz

c     compute local grid sizes

       ny = ngy/nsy
       nz = ngz/nsz

      if(blockid.eq.ncontrol) then      
      write(6,1831) nsy,nsz
1831  format(/1x,'# subdomains  in y-direction nsy = ',i5,/,
     $       1x,'# subdomains   in z-direction nsz = ',i5)
      write(6,2831) ncontrol
2831  format(/1x,'# control subdomain ncontrol = ',i5)

      write(6,3831) ngy,ngz
3831  format(/1x,'Global # elements  in y-direction ngy = ',i5,/,
     $       1x, 'Global # elements  in z-direction ngz = ',i5)

      write(6,8831) nx,ny,nz
 8831 format(/1x,'Local # elements  in x-direction nx = ',i5,/,
     $       1x, 'Local # elements  in y-direction ny = ',i5,/,
     $       1x, 'Local # elements  in z-direction nz = ',i5)
      write(6,1)xsize
 1    format(/1x,' domain size xsize = ',e20.8,' m')
      write(6,2) ysize
 2    format(/1x,' domain size ysize = ',e20.8,' m')     
      write(6,1111)zsize
1111  format(/1x,' domain size zsize = ',e20.8,' m')     
      endif
      if(nx.gt.mnx )   stop 1
      if(ny.gt.mny)    stop 1
      if(nz.gt.mnz)    stop 1

c  computes  processor grid sizes  hpy, hpz
           hpy = ysize/nsy
           hpz = zsize/nsz

       read(5,170)maxlow
       read(5,150)perclow
       if(blockid.eq.ncontrol) then
        write(6,1730)maxlow,perclow        
1730   format(/1x,'  maxlow (max.iter. in low freq range ) = ',
     1 i6,' perclow ( perc. of(low) freq. solved with maxlow = ', 
     1 e20.8)
          endif
	  
       read(5,170) imax
       read(5,150) toler

       h = xsize/nx
       hh= h*h
       hhh = h*h*h
c
c   sets  location of the point source
c       
c  Reads  global physical position of the single point source  
c  (Ubicarla en el medio del cubo, desde inp)
      read(5,150) xsou
      read(5,150) ysou
      read(5,150) zsou
c
c gets global position of source 
c
      if(xsou.lt.h) xsou=h
      if(xsou.gt.(xsize-h)) xsou=xsize-h
      if(ysou.lt.h) ysou=h
      if(ysou.gt.(ysize-h)) ysou=ysize-h 
      if(zsou.lt.h) zsou=h
      if(zsou.gt.(zsize-h)) zsou=zsize-h  
c
c  gets  local grid coordinates ( ksou,lsou) for the source
c  and sourceid  with the blockid number where the source
c  is located.
        ks = ysou/hpy
         ls = zsou/hpz
          ls = (nsz-1)-ls
c
c gets blockid where the source is located
c
        isourid = ls*nsy + ks
         souvid1 = mod(isourid,nsy)
          souvid2 = isourid/nsy
c
c       souvid1 *hpy = y-coordinate of the block isourid where
c                       the source is located

           ysourbl= souvid1*hpy

c        ((nsz-1)-souvid2)*hpz = z-coordinate of the  block where
c                                the source is located

              zsourbl = ((nsz-1)-souvid2)*hpz
              
           ysloc = ysou-ysourbl
           zsloc = zsou-zsourbl

      ksou = int(ysloc/h + 1.0d0)
      lsou = int(zsloc/h + 1.0d0)

      if(ksou.gt.ny.or.ksou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5693)ksou
5693   format(/1x,' wrong ksou = ',i5)
       endif 
       stop 444
        endif

      if(lsou.gt.nz.or.lsou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5697)lsou
5697   format(/1x,' wrong lsou = ',i5)
       endif 
       stop 444
        endif
c      
      jsou=int(xsou/h+1.d0)
      if(blockid.eq.ncontrol) then
      write(6,7725)jsou,ksou,lsou
 7725 format(/1x,' jsou = ',i5,' ksou = ',i5,'  lsou = ',i5)
       write(6,7722)xsou,ysou,zsou
 7722 format(/1x,' xsou = ',e20.8,' m ysou = ',e20.8,' m',
     1            ' zsou = ',e20.8)
       write(6,8833) h
8833   format(/1x,' mesh size h= ',e20.8,' m')
      write(6,5539)jsou,ksou,lsou,isourid
5539  format(/1x,' local source index  jsou = ',i5,
     1       ' ksou =',i5,' lsou = ',i5,' isourid =',i5) 
      endif   
 
      srx=xsou-(jsou-1)*h
      sry=ysloc-(ksou-1)*h
      srz=zsloc-(lsou-1)*h
c
c  Reads  global physical position of receivers
      read(5,170)nrec
      do ii=1,nrec
       read(5,150) rex(ii)
       read(5,150) rey(ii)
       read(5,150) rez(ii)
      enddo
         do  1947     ii=1,nrec

        if(rex(ii).lt.h) rex(ii)=h
        if(rex(ii).gt.(xsize-h)) rex(ii)=xsize-h
        if(rey(ii).lt.h) rey(ii)=h
        if(rey(ii).gt.(ysize-h)) rey(ii)=ysize-h
        if(rez(ii).lt.h) rez(ii)=h
        if(rez(ii).gt.(zsize-h)) rez(ii)=zsize-h

c
c       gets  local grid corrdinates (iry(ii),irz(ii)) for the receivers
c       and recid  with the blockid number where the receiver
c       is located.
c
        kre = rey(ii)/hpy
         lre = rez(ii)/hpz
          lre = (nsz-1)-lre

c       gets blockid where the receiver is located
c
        irecid(ii) = lre*nsy + kre
         recid1 = mod(irecid(ii),nsy)
          recid2 = irecid(ii)/nsy

c       recid1 *hpy = y-coordinate of the block irecid(ii) where
c                       the actual receiver is located

           yrecbl= recid1*hpy

c        ((nsz-1)-recid2)*hpz = z-coordinate of the  block irecid(ii) 
c                               where the actual receiver is located

              zrecbl = ((nsz-1)-recid2)*hpz
           yrloc = rey(ii)-yrecbl
           zrloc = rez(ii)-zrecbl

        iry(ii) = int(yrloc/h + 1.0d0)
        irz(ii) = int(zrloc/h + 1.0d0)

        j1(ii)  =int(rex(ii)/h+1.d0)
        k1(ii)  =iry(ii)
        l1(ii)  =irz(ii)

        rrx(ii)=rex(ii)-(j1(ii)-1)*h
        rry(ii)=yrloc-(k1(ii)-1)*h
        rrz(ii)=zrloc-(l1(ii)-1)*h

        if(blockid.eq.ncontrol) then
         write(6,7727) ii,irecid(ii),j1(ii),k1(ii),l1(ii),
     $                 rex(ii),rey(ii),rez(ii)
     
 7727    format(/1x,'receiver ii =',i5,3x,' irecid(ii) = ',
     $        i5,/,'  local indices  ',
     $            ' j1 = ',i5,'  k1 = ',i5,' l1 = ',i5,/,
     $     ' rex(ii) = ',e12.5,' m  rey(ii) = ',e12.5,
     $     '  m   rez(ii) = ',e12.5,'  m')
        endif

                 if(k1(ii).lt.1.or.k1(ii).gt.ny+1)then
           if(blockid.eq.ncontrol) then
             write(6,7729) ii,k1(ii),ny+1
 7729   format(/1x,'receiver ii =',i5,3x,'k1(ii)  = ',i5,
     $     'ny+1  = ',i5)             
           endif
              stop  88888
                  endif

                  if(l1(ii).lt.1.or.l1(ii).gt.nz+1)then

          if(blockid.eq.ncontrol) then
            write(6,7750) ii,l1(ii),nz+1
 7750     format(/1x,'receiver ii =',i5,3x,' l1(ii)  = ',i5,
     $     'nz+1  = ',i5)            
          endif
              stop  88888

                   endif

1947      continue
c
       read(5,170)nwsnap
       read(5,150)(wsnap(i),i=1,nwsnap)
       read(5,170) ntsnap
       read(5,150) (tsnap(i),i=1,ntsnap)
       read(5,170)npf
       read(5,170)key
       read(5,150)freq
       read(5,150)stime
       read(5,150)f1
       read(5,150)f2
       read(5,150)f3
       read(5,150)f4
       if(blockid.eq.ncontrol) then
           write(6,2190)imax
2190     format(/1x,'  imax =  max. # inner iterations ',i5)
           write(6,2590)toler
2590     format(/1x,'  toler =  relative error required  ',e20.8,/)
       write(6,76234)nwsnap
76234  format(/1x,' number of snapshots in freq. domain= ',i5)
       write(6,7746)(i,wsnap(i),i=1,nwsnap)
 7746  format(/1x,' freq. to compute  snapshots in freq.domain',/,
     $     i5,3x,e20.8,' kHz')
       write(6,76232)ntsnap
76232   format(/1x,' number of snapshots in time domain= ',i5)
      write(6,7741) (i,tsnap(i),i=1,ntsnap)
 7741  format(/1x,' times to compute  snapshots in time domain',/,
     $     i5,3x,e20.8,' msec')
       write(6,16234)npf
16234  format(/1x,' number of points to compute solution= ',/,
     1           ' in the frequency domain    npf  = ',i5)

      write(6,100)key
100   format(/1x,'  key==1 for type 1 source (tsang&rader paper) ;',
     $   /1x,'      key==2 for type 2 source(gaussian derivative)
     $      ;',i5,//)

      write(6,1305)freq
1305  format(/1x,'  frequency  freq= ',e20.8,' khz'//)
         write(6,7752)f1,f2,f3,f4
7752   format(/1x,'  parameters of  source band-pass filter',//,
     1         ' set equal to 0. if not filter is desired'//,
     1         ' f1  = ',e20.8,'   khz ',//,
     1         ' f2  = ',e20.8,'   khz ',//,
     1         ' f3  = ',e20.8,'   khz ',//,
     1         ' f4  = ',e20.8,'   khz ',//)
       endif
c
c    sets constants for ecah material type 
c    ( density, elastic bulk modulus, logarithmic decrement
c       fq1,fq2)

        call materials


c  computes  wave speed . In this case   speed = 1 m/msec = 1 km/sec
c
c      do i=1,nmat      
c       speed(i) = dsqrt( (xlammat(i)+2.d0*xmumat(i))/rhomat(i) )
c      enddo
c       vmax=speed(1)
c       vmin=speed(1)
c       do i=2,nmat
c       if(speed(i).gt.vmax) vmax=speed(i)
c       if(speed(i).lt.vmin) vmin=speed(i)
c       enddo       

       vmax=4.393d0
       vmin=1.860d0

c      HAY QUE AGREGAR ESTO EN MATERIALS DESPUES CON SPEED Y SPEEDS
c      VER QUE VELOC USO PARA CALCULAR CUANTOS PTOS LLEVA LA MALLA
c      Por ahora el espaciamiento de malla viene del inp. 

c  computes associated wavelength. In this case  wavelegth = 10^5 cm = 1 km
c
       wavel = vmin/freq
       npw = wavel/h
      if(blockid.eq.ncontrol) then
c       write(6,10) (speed(i),i=1,nmat)
10     format(/1x,' wave speed  = ',g15.5,' m/msec = km/sec ')       
       write(6,12)wavel
12     format(/1x,' wavelength  = ',g15.5,' meters ')       
       write(6,85)npw
85     format(/1x,' number of mesh points per wavelength =',i5)
      endif         

c    Esto sirve para controlar solamente. El h se calcula segun el inp     


c
c     computes dt using  cfl stability
c
       secfac = 1.d0
       dt = ( h/vmax) * secfac
c
c     computes number of time steps in n
c
       nt = stime/dt
       if(blockid.eq.ncontrol) then
       write(6,210)dt
210    format(/1x,' time step  dt = ',e20.8,' msec'//)
       write(6,200)nt
200    format(/1x,' number of time steps  nt = ',i6//)
       endif
       if(nt.gt.ntstep)stop 999
              
c
c     computes nyquist frequency
c
        fny =  1.d0/(2.d0*dt)
c
c     computes delf in khz using npf and the cut frequency f4
c
        fnpf=npf
        delf=f4/fnpf
        delw = twopi*delf

       if(blockid.eq.ncontrol) then
       write(6,1000)fny
1000   format(/1x,' nyquist frequency = ',e20.8,' khz')
       write(6,1001)f4
1001   format(/1x,' f4 = ',e20.8,' khz')
       if(f4.gt.fny) stop 98765
       write(6,1010)dt,delf,delw
1010   format(/1x,' dt  = ',e20.8,'  msec',//
     $           ' delf = ',e20.8,'  khz'//,
     $           ' delw = ',e20.8,'  2 pi*khz',//)
c
c       computes indices related to band-pass filters
c
         write(6,7752)f1,f2,f3,f4
        endif

       if1= f1/delf+1
       if2= f2/delf+1
       if3= f3/delf+1
       if4= f4/delf+1
       if(if4.eq.1)then
       f4=fny
       f3=.9d0*fny
       if3=f3/delf+1
       if4=f4/delf+1
       endif
       if(if3.eq.if4)if3=if4-1
c
c   computes indices iwsnap() related to snapshots in
c   the space- frequency domain
c
      do i=1,nwsnap
         iwsnap(i)= wsnap(i)/delf + 1.
      enddo
c
c   computes indices itsnap()  related to snapshots
c   in the space-time domain
c
      do i=1,ntsnap
         itsnap(i)= tsnap(i)/dt
      enddo
      if(blockid.eq.ncontrol) then
      write(6,66554)(i,iwsnap(i),i=1,nwsnap)
66554 format(/1x,' freq. indices for snapshots ',/,i5,2x,i5)
      write(6,66154)(i,itsnap(i),i=1,ntsnap)
66154 format(/1x,' time steps for snapshots ',/,i5,2x,i5)
      endif

      jw1=1
c    computes jw2 = last index for frequencies
c     the source fourier transform is zero for  jw.ge.if4
c    after filtering with the low-pass filter
c
      jw2=if4-1
         calcw = perclow * jw2
          jwlow = calcw
      if(blockid.eq.ncontrol) then
       write(6,6389)if1,if2,if3,if4
 6389  format(/1x,' if1 if2 if3 if4 =',4i6)
         write(6,8724)jw1,jw2,jwlow
 8724    format(/1x,'jw1 - jw2 - jwlow ',3i7)
      endif
c
c     now computes time shape of pulse in  source(n)
c     according to  key (type of source)
c
      w0 = twopi*freq
      alfa= .79d0 * w0/pi
      if(blockid.eq.ncontrol) then
      write(6,1405)w0,alfa
1405   format(/1x,' w0 = ',e20.8,'  alfa = ',e20.8,//)
      endif

      if(key.eq.2)then
c
c   Gaussian derivative source
c
      psi=8.d0*freq**2
      width=.5d0/freq
c      ts=2.5d0*width
      ts=2.d0*width
c      totpul=6.0d0*ts
      totpul=3.0d0*ts
      lpulse=totpul/dt+1.0001d0
      if(blockid.eq.ncontrol) then
      write(6,107)psi,width
      write(6,117)ts,totpul
      write(6,378)lpulse,nt
 107  format(/1x,'psi=',e20.8,'width=',e20.8,'msec')
 117  format(/1x,'ts=',e20.8,'msec. totpul=',e20.8,'msec')
 378  format(/1x,' pulse length in samples',i8,'  nt =  ',i8)
      endif
       if(lpulse.gt.ntstep) stop 34592
c
      if(nt.lt.lpulse)nt=lpulse
      do n=1,nt
      tt=(n-1)*dt
      aux=psi*(tt-ts)**2
      source(n)=-2.d0*psi*(tt-ts)*dexp(-aux)
      enddo
        endif
c
        if(key .eq. 1) then
c
c      source in Tsang&Rader paper
c
      do n=1,nt
      tt=(n-1)*dt
      source(n) = 4.d0*alfa*tt * exp(-alfa*tt)*dsin(w0*tt)
      enddo
            endif

        if(key .eq. 3) then
c
c    bymodal source like the one in Tsang& Rader  with    w1 = 2 * w0
c
         w1 = 2.d0*w0

      do n=1,nt
      tt=(n-1)*dt
      source(n) = 4.d0*alfa*tt * exp(-alfa*tt)*
     1            (dsin(w0*tt) + dsin(w1*tt) )
       enddo
            endif
c
      if(key.eq.4) then
c
c    Ricker de Carcione
c
        tt0=70.d0
        ff=0.032d0
        do n=1,nt
           tt=(n-1)*dt
           source(n)=dexp(-.5d0*ff**2*(tt-tt0)**2)*
     #	             dcos(pi*ff*(tt-tt0))   
        enddo
      endif
c
c       forces the max value of the source to be one
c
        xmax = 0.d0
        do n=1,nt
        if(dabs(source(n)).gt.xmax) xmax = dabs(source(n))
        enddo

        do n=1,nt
        source(n) = source(n)/xmax
         if(dabs(source(n)).lt.1.e-14) source(n) = 0.d0
        enddo
c
c     writes in 1 source time shape before filtering
c
      if(blockid.eq.ncontrol) then
      write(1,270)((n-1)*dt,source(n),n=1,nt)
      endif
270   format(2e20.8)
c
c     computes amplitude and phase of the periodic source

      call ffu2
c
c     writes amplitude  spectrum in  2
c
      if(blockid.eq.ncontrol) then
      write(2,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(fx(n))**2
     1              + dimag(fx(n))**2),n=1,jw2)
      endif
c
c     low-pass filter for the source
c
      if(if3.ne.1)then
       do jw=if3,if4
       fif3=if3
       fif4=if4
       fjw=jw
       fact=(fif4-fjw)/(fif4-fif3)
       fx(jw) = fx(jw) * fact
       enddo
       endif
c
c     compute new amplitude spectrum of the source after filtering
c
      if(blockid.eq.ncontrol) then
      write(3,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(fx(n))**2
     1              + dimag(fx(n))**2),n=1,jw2)
      endif
c
c    stores filtered source fourier transform  in fsour
c

      do n=1,jw2
      fsour(n) = fx(n)

      enddo
c
c      computes  inverse fourier transform
c      to obtain the  filtered source in  the time domain
c
         call finvu2
      do n=1,nt
      source(n) = tx(n)
      enddo
c
c      writes in 4   filtered source in time domain
c
        if(blockid.eq.ncontrol) then
        write(4,270)((n-1)*dt,source(n),n=1,nt)
        endif
c paso a fuente a segundos
c        write(4,270)((n-1)*dt*0.001d0,source(n),n=1,nt)
        close(1)
        close(2)
        close(3)
        close(4)
c
c    reads 3-d earth  material description
c
c    matnum(i) = global material type number for material of type  i
c
700    continue
                     
       read(5,150) xi
       read(5,150) xf
       read(5,150) yi
       read(5,150) yf
       read(5,150) zi
       read(5,150) zf
       read(5,170) numat
       if(blockid.eq.ncontrol) then
       write(6,710) xi,xf,yi,yf,zi,zf,numat
       endif
710    format(   ' from  xi                     = ',e20.8,' m  ',/
     1           ' up to xf                     = ',e20.8,' m ',/
     1           ' from  yi                     = ',e20.8,' m  ',/
     1           ' up to yf                     = ',e20.8,' m ',/
     1           ' from  zi                     = ',e20.8,' m  ',/
     1           ' up to zf                     = ',e20.8,' m ',/
     1           ' material type number  numat  = ',i5/)

        if(xi.lt.0.d0) go to 720
c
        xi = xi + .5d0*h
        xf = xf - .5d0*h

        yi = yi + .5d0*h
        yf = yf - .5d0*h

        zi = zi + .5d0*h
        zf = zf - .5d0*h

        ixi= xi/h + 1.0d0
        ixf= xf/h + 1.0d0
        iyi= yi/h + 1.0d0
        iyf= yf/h + 1.0d0
        izi= zi/h + 1.0d0
        izf= zf/h + 1.0d0

      if(blockid.eq.ncontrol) then
       write(6,730) ixi,ixf,iyi,iyf,izi,izf,numat
  730  format(   ' from  ixi (x-global grid #)    = ',i5,/
     1           ' up to ixf (x-global grid #)    = ',i5,/
     1           ' from  iyi (y-global grid #)    = ',i5,/
     1           ' up to iyf (y-global grid #)    = ',i5,/
     1           ' from  izi (z-global grid #)    = ',i5,/
     1           ' up to izf (z-global grid #)    = ',i5,/
     1           ' material type number  numat    = ',i5/)

        if(ixi.lt.1.or.ixi.gt.nx)then
        write(6,6629)ixi
6629     format(/1x,' wrong material description  ixi = ',i5)
           stop
            endif

        if(iyi.lt.1.or.iyi.gt.ngy)then
        write(6,6129)iyi
6129     format(/1x,' wrong material description  iyi = ',i5)
           stop
            endif

        if(izi.lt.1.or.izi.gt.ngz)then
        write(6,6291)izi
6291     format(/1x,' wrong material description  izi = ',i5)
           stop
            endif

        if(ixf.lt.1.or.ixf.gt.nx)then
        write(6,6229)ixf
6229     format(/1x,' wrong material description  ixf = ',i5)
           stop
            endif

        if(iyf.lt.1.or.iyf.gt.ngy)then
        write(6,6669)iyf
6669     format(/1x,' wrong material description  iyf = ',i5)
           stop
            endif

        if(izf.lt.1.or.izf.gt.ngy)then
        write(6,6662)izf
6662     format(/1x,' wrong material description  izf = ',i5)
           stop
            endif

          if(numat.lt.1.or.numat.gt.nmat)then
        write(6,8629)numat
8629     format(/1x,' wrong material number numat  = ',i5)
           stop
            endif
       endif

       do j=ixi,ixf
       do k=iyi,iyf
       do l=izi,izf

       matnum(j,k,l)=numat

       enddo
       enddo
       enddo
       go to 700
720    continue

	  do y=0,ngy+1
	    do z=0,ngz+1
	      matnum(0,y,z)=matnum(1,y,z)
	      matnum(nx+1,y,z)= matnum(nx,y,z)
	    enddo
	  enddo      
       
	  do x=0,nx+1
	    do z=0,ngz+1
	      matnum(x,0,z)=matnum(x,1,z)
	      matnum(x,ngy+1,z)= matnum(x,ngy,z)
	    enddo
	  enddo 
	  
	  
	  do x=0,nx+1
	    do y=0,ngy+1
	      matnum(x,y,0)=matnum(x,y,1)
	      matnum(x,y,ngz+1)= matnum(x,y,ngz)
	    enddo
	  enddo 	  

       return
       end
*********************************************************************
c
c     local base functions
c
************************************************************************  
      function th(x)      
      include 'commons.aniso'
      real*8 x,th,xh,xh2

      xh= -1.d0+ 2.d0*x/h
      xh2=xh*xh
      th=xh2-(5.d0/3.d0)*xh2*xh2

      return
      end

*************************************************************************
      function pf(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,xh,th,pf
 
      xh=  -1.d0+ 2.d0*x/h
      pf=1.d0/6.d0 +0.5d0*xh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(x)-th(y)-th(z))

      return
      end
************************************************************************
      function pb(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,xh,th,pb
 
      xh=  -1.d0+ 2.d0*x/h
      pb=1.d0/6.d0 -0.5d0*xh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(x)-th(y)-th(z))

      return
      end
************************************************************************
      function pe(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,yh,th,pe
 
      yh=  -1.d0+ 2.d0*y/h
      pe=1.d0/6.d0 +0.5d0*yh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(y)-th(x)-th(z))

      return
      end
************************************************************************
      function pw(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,yh,th,pw
 
      yh=  -1.d0+ 2.d0*y/h
      pw=1.d0/6.d0 -0.5d0*yh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(y)-th(x)-th(z))

      return
      end
************************************************************************
      function pn(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,zh,th,pn
 
      zh= -1.d0+ 2.d0*z/h
      pn=1.d0/6.d0 +0.5d0*zh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(z)-th(x)-th(y))

      return
      end
************************************************************************
      function ps(x,y,z)
      include 'commons.aniso'
      real*8 x,y,z,zh,th,ps
 
      zh= -1.d0+ 2.d0*z/h
      ps=1.d0/6.d0 -0.5d0*zh +(1.d0/(6.d0*th(h)))
     1   *(2.d0*th(z)-th(x)-th(y))

      return
      end
*********************************************************************
      subroutine ffu2
       implicit none
      include 'commons.aniso'
      real*8 fjt,v
      integer jt

      do jw = 1,jw2
      fjw = jw
      fjw = fjw-1.d0
      fjw = fjw + .5d0
      fx(jw) = dcmplx(0.d0,0.d0)
      do jt = 1,nt
      fjt = jt
      fjt = fjt - 1.d0
      v = fjw*delw* fjt*dt
      v=-v
      fx(jw) = fx(jw) + source(jt) * dcmplx(dcos(v),dsin(v))
      enddo
      fx(jw)=fx(jw)*dt
      enddo
      return
      end
**************************************************************************
      subroutine finvu2
       implicit none
      include 'commons.aniso'
      real*8 fjt,v
      integer jt

      do jt = 1,nt
      fjt=jt
      fjt = fjt - 1.d0
      tx(jt) = 0.d0
      do jw=1,jw2
      fjw=jw
      fjw = fjw -1.d0
      fjw = fjw + .5d0
      v = fjw * delw * fjt * dt
      tx(jt) = tx(jt)+dreal(fx(jw)*dcmplx(dcos(v),dsin(v)))
      enddo
      tx(jt)=tx(jt)*delw/pi
      enddo
      return
      end
*********************************************************************
c       subroutine finvpic2_planos
c       implicit none
c      include 'commons.aniso'
c      real*8 fjt,v
c      integer jt,x,y,z
c      complex*16 avsol      

c elegir donde realizar los cortes
c        do z=1,nz
c	  do y=1,ny
c      avsol= (u1f(nx-2,y,z)+u1e(nx-2,y,z)+u1n(nx-2,y,z)+
c     $        u1b(nx-2,y,z)+u1w(nx-2,y,z)+u1s(nx-2,y,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic1yz(y,z,jt) = tpic1yz(y,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do z=1,nz
c	  do y=1,ny
c      avsol= (u2f(nx-2,y,z)+u2e(nx-2,y,z)+u2n(nx-2,y,z)+
c     $        u2b(nx-2,y,z)+u2w(nx-2,y,z)+u2s(nx-2,y,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic2yz(y,z,jt) = tpic2yz(y,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do z=1,nz
c	  do y=1,ny
c      avsol= (u3f(nx-2,y,z)+u3e(nx-2,y,z)+u3n(nx-2,y,z)+
c     $        u3b(nx-2,y,z)+u3w(nx-2,y,z)+u3s(nx-2,y,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic3yz(y,z,jt) = tpic3yz(y,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do z=1,nz
c	  do x=1,nx
c      avsol= (u1f(x,ny-2,z)+u1e(x,ny-2,z)+u1n(x,ny-2,z)+
c     $        u1b(x,ny-2,z)+u1w(x,ny-2,z)+u1s(x,ny-2,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic1xz(x,z,jt) = tpic1xz(x,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do z=1,nz
c	  do x=1,nx
c      avsol= (u2f(x,ny-2,z)+u2e(x,ny-2,z)+u2n(x,ny-2,z)+
c     $        u2b(x,ny-2,z)+u2w(x,ny-2,z)+u2s(x,ny-2,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic2xz(x,z,jt) = tpic2xz(x,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do z=1,nz
c	  do x=1,nx
c      avsol= (u3f(x,ny-2,z)+u3e(x,ny-2,z)+u3n(x,ny-2,z)+
c     $        u3b(x,ny-2,z)+u3w(x,ny-2,z)+u3s(x,ny-2,z))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic3xz(x,z,jt) = tpic3xz(x,z,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do y=1,ny
c	  do x=1,nx
c      avsol= (u1f(x,y,nz-2)+u1e(x,y,nz-2)+u1n(x,y,nz-2)+
c     $        u1b(x,y,nz-2)+u1w(x,y,nz-2)+u1s(x,y,nz-2))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic1xy(x,y,jt) = tpic1xy(x,y,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
c
c        do y=1,ny
c	  do x=1,nx
c      avsol= (u2f(x,y,nz-2)+u2e(x,y,nz-2)+u2n(x,y,nz-2)+
c     $        u2b(x,y,nz-2)+u2w(x,y,nz-2)+u2s(x,y,nz-2))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic2xy(x,y,jt) = tpic2xy(x,y,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        do y=1,ny
c	  do x=1,nx
c      avsol= (u3f(x,y,nz-2)+u3e(x,y,nz-2)+u3n(x,y,nz-2)+
c     $        u3b(x,y,nz-2)+u3w(x,y,nz-2)+u3s(x,y,nz-2))/6.d0 
c              do jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic3xy(x,y,jt) = tpic3xy(x,y,jt) +
c     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
c              enddo
c	  enddo
c        enddo
cc
c        return
c        end
*********************************************************************
       subroutine finvpic2_cubos
       implicit none
      include 'commons.aniso'
      real*8 fjt,v
      integer jt,x,y,z
      complex*16 avsol      

        do z=1,nz
	  do y=1,ny
            do x=1,nx
      avsol= (u1f(x,y,z)+u1e(x,y,z)+u1n(x,y,z)+
     $        u1b(x,y,z)+u1w(x,y,z)+u1s(x,y,z))/6.d0 
              do jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic1(x,y,z,jt) = tpic1(x,y,z,jt) +
     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
              enddo
            enddo
	  enddo
        enddo
c
        do z=1,nz
	  do y=1,ny
            do x=1,nx
      avsol= (u2f(x,y,z)+u2e(x,y,z)+u2n(x,y,z)+
     $        u2b(x,y,z)+u2w(x,y,z)+u2s(x,y,z))/6.d0 
              do jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic2(x,y,z,jt) = tpic2(x,y,z,jt) +
     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
              enddo
            enddo
	  enddo
        enddo
c
        do z=1,nz
	  do y=1,ny
            do x=1,nx
      avsol= (u3f(x,y,z)+u3e(x,y,z)+u3n(x,y,z)+
     $        u3b(x,y,z)+u3w(x,y,z)+u3s(x,y,z))/6.d0 
              do jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic3(x,y,z,jt) = tpic3(x,y,z,jt) +
     $              dreal( avsol * dcmplx(dcos(v),dsin(v)) )
              enddo
            enddo
	  enddo
        enddo

        return
        end
*********************************************************************
cc         parallel printout functions
cc
c      subroutine tgprint_planos
c      implicit none
c      include 'commons.aniso'
c      integer nn,i,j,nsize1,nsize2,nsize3
c      real*8 avunvec1(0:(mny+2)*(mnz+2)),avunvec2(0:(mny+2)*(mnz+2))
c      real*8 avunvec3(0:(mny+2)*(mnz+2))
c      real*8 avunvec4(0:mnx*(mnz+2)),avunvec5(0:mnx*(mnz+2))
c      real*8 avunvec6(0:mnx*(mnz+2))
c      real*8 avunvec7(0:mnx*(mny+2)),avunvec8(0:mnx*(mny+2))
c      real*8 avunvec9(0:mnx*(mny+2))

c      if(blockid.eq.0)then
c         open(unit=100,file='t1yz.t',status='unknown')
c         open(unit=150,file='t2yz.t',status='unknown')
c         open(unit=200,file='t3yz.t',status='unknown')
c         open(unit=250,file='t1xz.t',status='unknown')
c         open(unit=300,file='t2xz.t',status='unknown')
c         open(unit=350,file='t3xz.t',status='unknown')
c         open(unit=400,file='t1xy.t',status='unknown')
c         open(unit=450,file='t2xy.t',status='unknown')
c         open(unit=500,file='t3xy.t',status='unknown')
c      endif
cc
c         nsize1=nz*ny+1
c         nsize2=nx*nz+1
c         nsize3=nx*ny+1
cc
c      do nn=1,ntsnap
c         avunvec1(0) = tsnap(nn)
c         avunvec2(0) = tsnap(nn)
c         avunvec3(0) = tsnap(nn)
c         avunvec4(0) = tsnap(nn)
c         avunvec5(0) = tsnap(nn)
c         avunvec6(0) = tsnap(nn)
c         avunvec7(0) = tsnap(nn)
c         avunvec8(0) = tsnap(nn)
c         avunvec9(0) = tsnap(nn)
cc
c         do j=0,nz-1
c         do i=0,ny-1 
c          avunvec1(1+i+j*ny) = tpic1yz(i+1,j+1,nn)
c          avunvec2(1+i+j*ny) = tpic2yz(i+1,j+1,nn)
c          avunvec3(1+i+j*ny) = tpic3yz(i+1,j+1,nn)
c         enddo     
c         enddo
cc
c         do j=0,nz-1
c         do i=0,nx-1 
c          avunvec4(1+i+j*nx) = tpic1xz(i+1,j+1,nn)
c          avunvec5(1+i+j*nx) = tpic2xz(i+1,j+1,nn)
c          avunvec6(1+i+j*nx) = tpic3xz(i+1,j+1,nn)
c         enddo     
c         enddo
cc
c         do j=0,ny-1
c         do i=0,nx-1 
c          avunvec7(1+i+j*nx) = tpic1xy(i+1,j+1,nn)
c          avunvec8(1+i+j*nx) = tpic2xy(i+1,j+1,nn)
c          avunvec9(1+i+j*nx) = tpic3xy(i+1,j+1,nn)
c         enddo     
c         enddo 
cc
c      if(blockid.eq.0)then
c       write(100,44)avunvec1(0)
c       write(150,44)avunvec2(0)
c       write(200,44)avunvec3(0)
c       write(250,44)avunvec4(0)
c       write(300,44)avunvec5(0)
c       write(350,44)avunvec6(0)
c       write(400,44)avunvec7(0)
c       write(450,44)avunvec8(0)
c       write(500,44)avunvec9(0)
c       write(100,44)(avunvec1(i)*delw/pi,i=1,nz*ny)
c       write(150,44)(avunvec2(i)*delw/pi,i=1,nz*ny)
c       write(200,44)(avunvec3(i)*delw/pi,i=1,nz*ny)
c       write(250,44)(avunvec4(i)*delw/pi,i=1,nx*nz)
c       write(300,44)(avunvec5(i)*delw/pi,i=1,nx*nz)
c       write(350,44)(avunvec6(i)*delw/pi,i=1,nx*nz)
c       write(400,44)(avunvec7(i)*delw/pi,i=1,nx*ny)
c       write(450,44)(avunvec8(i)*delw/pi,i=1,nx*ny)
c       write(500,44)(avunvec9(i)*delw/pi,i=1,nx*ny)
c44     format(e12.5)
c         do j=1,nsy*nsz-1
cc      / block 0  receives and print data from node j */
c
c        call cmrect_1(j,1,avunvec1,nsize1)
c        call cmrect_1(j,1,avunvec2,nsize1)
c        call cmrect_1(j,1,avunvec3,nsize1)
c        call cmrect_2(j,1,avunvec4,nsize2)
c        call cmrect_2(j,1,avunvec5,nsize2)
c        call cmrect_2(j,1,avunvec6,nsize2)
c        call cmrect_3(j,1,avunvec7,nsize3)
c        call cmrect_3(j,1,avunvec8,nsize3)
c        call cmrect_3(j,1,avunvec9,nsize3)
cc     writes in 100, 150, etc. information received from node j
cc
c       write(100,44)avunvec1(0)
c       write(150,44)avunvec2(0)
c       write(200,44)avunvec3(0)
c       write(250,44)avunvec4(0)
c       write(300,44)avunvec5(0)
c       write(350,44)avunvec6(0)
c       write(400,44)avunvec7(0)
c       write(450,44)avunvec8(0)
c       write(500,44)avunvec9(0)       
c       write(100,44)(avunvec1(i)*delw/pi,i=1,nz*ny)
c       write(150,44)(avunvec2(i)*delw/pi,i=1,nz*ny)
c       write(200,44)(avunvec3(i)*delw/pi,i=1,nz*ny)
c       write(250,44)(avunvec4(i)*delw/pi,i=1,nx*nz)
c       write(300,44)(avunvec5(i)*delw/pi,i=1,nx*nz)
c       write(350,44)(avunvec6(i)*delw/pi,i=1,nx*nz)
c       write(400,44)(avunvec7(i)*delw/pi,i=1,nx*ny)
c       write(450,44)(avunvec8(i)*delw/pi,i=1,nx*ny)
c       write(500,44)(avunvec9(i)*delw/pi,i=1,nx*ny)
c         enddo
c       else
cc
cc      /* Current node sends data to node 0 */
cc
c        call cmsendt_1(0,1,avunvec1,nsize1)
c        call cmsendt_1(0,1,avunvec2,nsize1)
c        call cmsendt_1(0,1,avunvec3,nsize1)
c        call cmsendt_2(0,1,avunvec4,nsize2)
c        call cmsendt_2(0,1,avunvec5,nsize2)
c        call cmsendt_2(0,1,avunvec6,nsize2)
c        call cmsendt_3(0,1,avunvec7,nsize3)
c        call cmsendt_3(0,1,avunvec8,nsize3)
c        call cmsendt_3(0,1,avunvec9,nsize3)
c       endif
c      enddo
c
c      return
c      end
**********************************************************************
c         parallel printout functions
c
      subroutine tgprint_cubos
      implicit none
      include 'commons.aniso'
      integer nn,i,j,nsizec,x,y,z,ik,il,ii
      real*8 avunvec1(0:mnx*(mny+2)*(mnz+2))
      real*8 avunvec2(0:mnx*(mny+2)*(mnz+2))
      real*8 avunvec3(0:mnx*(mny+2)*(mnz+2))
      real*8 posz,auxz,posy,auxy

100    format(g20.8)
200    format(3i5,g20.8)

       do nn=1,ntsnap
         write(100+blockid,100) tsnap(nn)
          do z=1,nz
            posz = ((nsz-1)-vblockid(2))*hpz+ (z-1)*h + 0.5d0*h
            auxz = posz/h +1.d0
            il =int(auxz)
           do y=1,ny
            posy = vblockid(1)*hpy + (y-1)*h +.5d0*h
	    auxy = posy/h +1.d0
	    ik =int(auxy)
            do x=1,nx
             write(100+blockid,200) x,ik,il,tpic1(x,y,z,nn)*delw/pi
            enddo
           enddo
          enddo
       enddo

       do nn=1,ntsnap
         write(200+blockid,100) tsnap(nn)
          do z=1,nz
            posz = ((nsz-1)-vblockid(2))*hpz+ (z-1)*h + 0.5d0*h
            auxz = posz/h +1.d0
            il =int(auxz)
           do y=1,ny
            posy = vblockid(1)*hpy + (y-1)*h +.5d0*h
	    auxy = posy/h +1.d0
	    ik =int(auxy)
            do x=1,nx
             write(200+blockid,200) x,ik,il,tpic2(x,y,z,nn)*delw/pi
            enddo
           enddo
          enddo
       enddo
c
       do nn=1,ntsnap
         write(300+blockid,100) tsnap(nn)
          do z=1,nz
            posz = ((nsz-1)-vblockid(2))*hpz+ (z-1)*h + 0.5d0*h
            auxz = posz/h +1.d0
            il =int(auxz)
           do y=1,ny
            posy = vblockid(1)*hpy + (y-1)*h +.5d0*h
	    auxy = posy/h +1.d0
	    ik =int(auxy)
            do x=1,nx
             write(300+blockid,200) x,ik,il,tpic3(x,y,z,nn)*delw/pi
            enddo
           enddo
          enddo
       enddo
c
c      if(blockid.eq.0)then
c         open(unit=100,file='cubo_t1.t',status='unknown')
c         open(unit=200,file='cubo_t2.t',status='unknown')
c         open(unit=300,file='cubo_t3.t',status='unknown')
c      endif
cc
c         nsizec=nz*ny*nx+1
cc
c      do nn=1,ntsnap
c         avunvec1(0) = tsnap(nn)
c         avunvec2(0) = tsnap(nn)
c         avunvec3(0) = tsnap(nn)
cc
c         do j=0,nz-1
c         do i=0,ny-1 
c         do x=1,nx
c          avunvec1(1+i*nx+j*nx) = tpic1(x,i+1,j+1,nn)
c          avunvec2(1+i*nx+j*nx) = tpic2(x,i+1,j+1,nn)
c          avunvec3(1+i*nx+j*nx) = tpic3(x,i+1,j+1,nn)
c         enddo
c         enddo     
c         enddo
cc
c      if(blockid.eq.0)then
c       write(600,44)avunvec1(0)
c       write(650,44)avunvec2(0)
c       write(700,44)avunvec3(0)
c       write(600,44)(avunvec1(i)*delw/pi,i=1,nz*ny*nx)
c       write(650,44)(avunvec2(i)*delw/pi,i=1,nz*ny*nx)
c       write(700,44)(avunvec3(i)*delw/pi,i=1,nz*ny*nx)
44     format(e12.5)
c         do j=1,nsy*nsz-1
c      / block 0  receives and print data from node j */
cc
c        call cmrect_c(j,1,avunvec1,nsizec)
c        call cmrect_c(j,1,avunvec2,nsizec)
c        call cmrect_c(j,1,avunvec3,nsizec)

cc     writes in 600, 650, 700 information received from node j
cc
c       write(100,44)avunvec1(0)
c       write(150,44)avunvec2(0)
c       write(200,44)avunvec3(0)
c       write(100,44)(avunvec1(i)*delw/pi,i=1,nz*ny*nx)
c       write(150,44)(avunvec2(i)*delw/pi,i=1,nz*ny*nx)
c       write(200,44)(avunvec3(i)*delw/pi,i=1,nz*ny*nx)
c         enddo
c       else
cc
cc      /* Current node sends data to node 0 */
cc
c        call cmsendt_c(0,1,avunvec1,nsizec)
c        call cmsendt_c(0,1,avunvec2,nsizec)
c        call cmsendt_c(0,1,avunvec3,nsizec)
c       endif
c      enddo

      return
      end
**********************************************************************
c       subroutine cmrect_1(b_id,dumb,trecc,size)
csp2----------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso'
c        integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------------------- 
c       integer b_id,dumb,itag,mpierr
c       real*8 trecc(0:(mny+2)*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2-----------------------------------------------------------------------
c        itag=1
c        call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,status,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif     
csp2  --------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmrect_2(b_id,dumb,trecc,size)
csp2----------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso'
c        integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------------------- 
c       integer b_id,dumb,itag,mpierr
c       real*8 trecc(0:mnx*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2-----------------------------------------------------------------------
c        itag=1
c        call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,status,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif     
csp2  --------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmrect_3(b_id,dumb,trecc,size)
csp2----------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso'
c        integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------------------- 
c       integer b_id,dumb,itag,mpierr
c       real*8 trecc(0:mnx*(mny+2))
c       integer size
c      TMP - PARALLEL CODE
csp2-----------------------------------------------------------------------
c        itag=1
c        call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,status,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif     
csp2  --------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmrect_c(b_id,dumb,trecc,size)
csp2----------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso'
c        integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------------------- 
c       integer b_id,dumb,itag,mpierr
c       real*8 trecc(0:mnx*(mny+2)*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2-----------------------------------------------------------------------
c        itag=1
c        call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,status,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif     
csp2  --------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmsendt_1(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso' 
csp2 -----------------------------------------------------------
c       integer b_id,dumb,itag,mpierr
c       real*8 tsendd(0:(mny+2)*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2 ---------------------------------------------------
c        itag=1
c        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif       
csp2 ---------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmsendt_2(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso' 
csp2 -----------------------------------------------------------
c       integer b_id,dumb,itag,mpierr
c       real*8 tsendd(0:mnx*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2 ---------------------------------------------------
c        itag=1
c        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif       
csp2 ---------------------------------------------------------
c       return
c       end
**********************************************************************
c       subroutine cmsendt_3(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso' 
csp2 -----------------------------------------------------------
c       integer b_id,dumb,itag,mpierr
c       real*8 tsendd(0:mnx*(mny+2))
c       integer size
c      TMP - PARALLEL CODE
csp2 ---------------------------------------------------
c        itag=1
c        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif       
csp2 ---------------------------------------------------------
c       return
c       end
*********************************************************************
c       subroutine cmsendt_c(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
c        include 'commons.aniso' 
csp2 -----------------------------------------------------------
c       integer b_id,dumb,itag,mpierr
c       real*8 tsendd(0:mnx*(mny+2)*(mnz+2))
c       integer size
c      TMP - PARALLEL CODE
csp2 ---------------------------------------------------
c        itag=1
c        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif       
csp2 ---------------------------------------------------------
c       return
c       end
*********************************************************************
c      subroutine outime
c       implicit none
c      include 'commons.aniso'
c      integer nn,x,y,z

c      do nn=1,ntsnap
c         do z=1,nz
c            do y=1,ny
c            write(9+nn,9157) tpic1yz(y,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do z=1,nz
c            do y=1,ny
cc            write(14+nn,9157) tpic2yz(y,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do z=1,nz
c            do y=1,ny
cc            write(19+nn,9157) tpic3yz(y,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do z=1,nz
c            do x=1,nx
c            write(24+nn,9157) tpic1xz(x,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do z=1,nz
c            do x=1,nx
c            write(29+nn,9157) tpic2xz(x,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do z=1,nz
c            do x=1,nx
c            write(34+nn,9157) tpic3xz(x,z,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do y=1,ny
c            do x=1,nx
c            write(39+nn,9157) tpic1xy(x,y,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do y=1,ny
c            do x=1,nx
c            write(44+nn,9157) tpic2xy(x,y,nn)*delw/pi
c            enddo
c         enddo
c       enddo
cc
c      do nn=1,ntsnap
c         do y=1,ny
c            do x=1,nx
c            write(49+nn,9157) tpic3xy(x,y,nn)*delw/pi
c            enddo
c         enddo
c       enddo
c9157  format(g15.4)
c
c          return
c          end
*********************************************************************
       subroutine solvub
       implicit none
       include 'commons.aniso'
        integer kk,ll,ik    

       do ll=1,nz
           if(mod(ll,2).ne.0) ik=1
           if(mod(ll,2).eq.0) ik=2
         do kk=ik,ny,2
             call rhssolve(ll,kk)
         enddo
       enddo
          return
	  end	    
***********************************************************************
       subroutine solvur
       implicit none
       include 'commons.aniso'
        integer kk,ll,ik

       do ll=1,nz
           if(mod(ll,2).ne.0) ik=2
           if(mod(ll,2).eq.0) ik=1
         do kk=ik,ny,2
             call rhssolve(ll,kk)
         enddo
       enddo	  
          return
	  end
***********************************************************************
      subroutine lhsLU(ll,kk)
       implicit none  
      include 'commons.aniso'
    
      integer x,y,i,jx,mm,nn,ir,ic,jj,ll,kk,j,k,l,ik,il
      real *8 aa,aux2,aux4,aux5,avrho,facbeta,posy,posz,auxy,auxz
      complex*16 aim
      real*8 avvp,avvs1,avvs2
      real*8 rhonx,rho1x,rhony,rho1y,rhonz,rho1z
      real*8 rhojm1,rhojp1,rhokm1,rhokp1,rholm1,rholp1
      complex*16 c11,c12,c13,c14,c15,c16
      complex*16 c22,c23,c24,c25,c26
      complex*16 c33,c34,c35,c36
      complex*16 c44,c45,c46,c55,c56,c66     
      complex*16 c11jm1,c11jp1,c11km1,c11kp1,c66km1,c66kp1,c66jm1
      complex*16 c66jp1,c44lm1,c44lp1,c44jm1,c44jp1,c44km1,c44kp1
      complex*16 c55lp1,c55lm1,c22kp1,c22km1
      complex*16 c33lm1,c33lp1,c55jm1,c55jp1
      
      aim=dcmplx(0.d0,1.d0)
      facbeta = 1.d0
      l=ll
      k=kk
              
      do x=1,nunk
        do y=1,35
	  a(x,y,k,l)= dcmplx(0.d0,0.d0)
	enddo
      enddo
c
c      do x=1,18
c        do y=1,18
c	  ma(x,y)= dcmplx(0.d0,0.d0)
c	enddo
c      enddo
c
c	Aca defino los coef c11, c33, c44, c66, c13 y rho (segun el material)
c     El material viene de solve (lo paso con los indices j,k,l)
c
c  computes Global position  coordinate in the  y-direction
c
          posy = vblockid(1)*hpy + (k-1)*h +.5d0*h
c
c  computes Global position  coordinate in the  z-direction
c
          posz = ((nsz-1)-vblockid(2))*hpz+ (l-1)*h + 0.5d0*h

	  auxy = posy/h +1.d0
          auxz = posz/h +1.d0

	  ik =int(auxy)
          il =int(auxz)
                 
                 do 1003 j=1,nx

       i = matnum(j,ik,il)
       c11=c11mat(i,jw)
       c12=c12mat(i,jw)
       c13=c13mat(i,jw)
       c14=c14mat(i,jw)
       c15=c15mat(i,jw)  
       c16=c16mat(i,jw)
       c22=c22mat(i,jw)
       c23=c23mat(i,jw)
       c24=c24mat(i,jw)
       c25=c25mat(i,jw)
       c26=c26mat(i,jw)
       c33=c33mat(i,jw)
       c34=c34mat(i,jw)
       c35=c35mat(i,jw)
       c36=c36mat(i,jw)   
       c44=c44mat(i,jw)
       c45=c45mat(i,jw)
       c46=c46mat(i,jw)
       c55=c55mat(i,jw)
       c56=c56mat(i,jw)
       c66=c66mat(i,jw)
       rho=rhomat(i)   

c       i = matnum(j-1,ik,il)
c       c11jm1=c11mat(i)
c       c55jm1=c55mat(i)
c       c66jm1=c66mat(i)
c       rhojm1=rhomat(i)

c       i = matnum(j+1,ik,il)
c       c11jp1=c11mat(i)
c       c55jp1=c55mat(i)
c       c66jp1=c66mat(i)
c       rhojp1=rhomat(i)

       i = matnum(j,ik-1,il)
       c22km1=c22mat(i,jw)
       c44km1=c44mat(i,jw)
       c66km1=c66mat(i,jw)
       rhokm1=rhomat(i)

       i = matnum(j,ik+1,il)
       c22kp1=c22mat(i,jw)
       c44kp1=c44mat(i,jw)
       c66kp1=c66mat(i,jw)
       rhokp1=rhomat(i)

       i = matnum(j,ik,il-1)
       c33lm1=c33mat(i,jw)
       c44lm1=c44mat(i,jw)
       c55lm1=c55mat(i,jw)
       rholm1=rhomat(i)
      
       i = matnum(j,ik,il+1)
       c33lp1=c33mat(i,jw)
       c44lp1=c44mat(i,jw)
       c55lp1=c55mat(i,jw)
       rholp1=rhomat(i)

c      aa=-rho*omega*omega 
c      aux2=82.d0*hh*aa
c      aux4=41.d0*hh*aa
c      aux5=233.d0*hh*aa
c
c Back comp. u1
c
      ma(1,1)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c11+37.d0*(c55+c66))/63.d0*h 
     
      ma(1,2)=(211.d0*c16+37.d0*(c26+c45))/63.d0*h
      
      ma(1,3)=(211.d0*c15+37.d0*(c46+c35))/63.d0*h
      
      ma(1,4)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #        (63.d0*c16-37.d0*c55+74.d0*(c11+c66))/63.d0*h 
     
      ma(1,5)=-(63.d0*c12-37.d0*c45+74.d0*(c16+c26))/63.d0*h
      
      ma(1,6)=-(63.d0*c14-37.d0*c35+74.d0*(c15+c46))/63.d0*h
      
      ma(1,7)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c16-74.d0*(c11+c66)+37.d0*c55)/63.d0*h 
     
      ma(1,8)=(63.d0*c12+37.d0*c45-74.d0*(c16+c26))/63.d0*h
      
      ma(1,9)=(63.d0*c14+37.d0*c35-74.d0*(c15+c46))/63.d0*h
      
      ma(1,10)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c15-37.d0*c66+74.d0*(c11+c55))/63.d0*h 
      
      ma(1,11)=-(63.d0*c14-37.d0*c26+74.d0*(c16+c45))/63.d0*h
      
      ma(1,12)=-(63.d0*c13-37.d0*c46+74.d0*(c15+c35))/63.d0*h
      
      ma(1,13)=-rho*omega*omega*hhh*41.d0/1890.d0 +      
     #          (63.d0*c15-74.d0*(c11+c55)+37.d0*c66)/63.d0*h
     
      ma(1,14)=(63.d0*c14-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
      
      ma(1,15)=(63.d0*c13-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
      
      ma(1,16)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c11+37.d0*(c55+c66))/63.d0*h
     
      ma(1,17)=(85.d0*c16+37.d0*(c45+c26))/63.d0*h
      
      ma(1,18)=(85.d0*c15+37.d0*(c35+c46))/63.d0*h
c
c Back comp. u2
c
      ma(2,1)=(211.d0*c16+37.d0*(c45+c26))/63.d0*h
      
      ma(2,2)=-rho*omega*omega*hhh*233.d0/1890.d0 +    
     #        (211.d0*c66+37.d0*(c22+c44))/63.d0*h 
     
      ma(2,3)=(211.d0*c56+37.d0*(c24+c34))/63.d0*h
      
      ma(2,4)=-(63.d0*c66+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
      
      ma(2,5)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #        (63.d0*c26+74.d0*(c66+c22)-37.d0*c44)/63.d0*h
     
      ma(2,6)=-(63.d0*c46+74.d0*(c56+c24)-37.d0*c34)/63.d0*h
      
      
      ma(2,7)=(63.d0*c66-74.d0*(c16+c26)+37.d0*c45)/63.d0*h
      
      ma(2,8)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c26-74.d0*(c66+c22)+37.d0*c44)/63.d0*h 
     
      ma(2,9)=(63.d0*c46-74.d0*(c56+c24)+37.d0*c34)/63.d0*h
      
      ma(2,10)=-(63.d0*c56+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
      
      ma(2,11)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
     
      ma(2,12)=(-63.d0*c36-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
      
      ma(2,13)=(63.d0*c56-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
      
      ma(2,14)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
     
      ma(2,15)=(63.d0*c36-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
      
      ma(2,16)=(85.d0*c16+37.d0*(c45+c26))/63.d0*h
      
      ma(2,17)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #         (85.d0*c66+37.d0*(c44+c22))/63.d0*h 
     
      ma(2,18)=(85.d0*c56+37.d0*(c24+c34))/63.d0*h
c
c Back comp. u3
c    
      ma(3,1)=(211.d0*c15+37.d0*(c35+c46))/63.d0*h
      
      ma(3,2)=(211.d0*c56+37.d0*(c24+c34))/63.d0*h
      
      ma(3,3)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c55+37.d0*(c44+c33))/63.d0*h
      
      ma(3,4)=-(63.d0*c56+74.d0*(c15+c46)-37.d0*c35)/63.d0*h
      
      ma(3,5)=-(63.d0*c25+74.d0*(c24+c56)-37.d0*c34)/63.d0*h
      
      ma(3,6)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (-63.d0*c45-74.d0*(c55+c44)+37.d0*c33)/63.d0*h
     
      ma(3,7)=(63.d0*c56-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
      
      ma(3,8)=(63.d0*c25-74.d0*(c24+c56)+37.d0*c34)/63.d0*h
      
      ma(3,9)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c45-74.d0*(c44+c55)+37.d0*c33)/63.d0*h 
     
      ma(3,10)=-(63.d0*c55+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
      
      ma(3,11)=(-63.d0*c45-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
      
      ma(3,12)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c35+74.d0*(c55+c33)-37.d0*c44)/63.d0*h
     
      ma(3,13)=(63.d0*c55-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
      
      ma(3,14)=(63.d0*c45-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
      
      ma(3,15)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c35-74.d0*(c33+c55)+37.d0*c44)/63.d0*h
     
      ma(3,16)=(85.d0*c15+37.d0*(c35+c46))/63.d0*h
       
      ma(3,17)=(85.d0*c56+37.d0*(c24+c34))/63.d0*h
      
      ma(3,18)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #         (85.d0*c55+37.d0*(c44+c33))/63.d0*h
c
c Este comp. u1
c  
      ma(4,1)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #        (63.d0*c16+74.d0*(c11+c66)-37.d0*c55)/63.d0*h
     
      ma(4,2)=-(63.d0*c66+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
      
      ma(4,3)=-(63.d0*c56+74.d0*(c15+c46)-37.d0*c35)/63.d0*h
      
      ma(4,4)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c66+37.d0*(c11+c55))/63.d0*h      
     
       ma(4,5)=(211.d0*c26+37.d0*(c16+c45))/63.d0*h
       
       ma(4,6)=(211.d0*c46+37.d0*(c15+c35))/63.d0*h
       
       ma(4,7)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c66+37.d0*(c11+c55))/63.d0*h
      
       ma(4,8)=(85.d0*c26+37.d0*(c16+c45))/63.d0*h
       
       ma(4,9)=(85.d0*c46+37.d0*(c15+c35))/63.d0*h
       
       ma(4,10)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c56-74.d0*(c55+c66)+37.d0*c11)/63.d0*h
      
       ma(4,11)=(63.d0*c46-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
       
       ma(4,12)=(63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
       
       ma(4,13)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c56-74.d0*(c55+c66)+37.d0*c11)/63.d0*h
      
       ma(4,14)=(-63.d0*c46-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
       
       ma(4,15)=(-63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
       
       ma(4,16)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c16-74.d0*(c11+c66)+37.d0*c55)/63.d0*h
      
       ma(4,17)=(63.d0*c66-74.d0*(c16+c26)+37.d0*c45)/63.d0*h
       
       ma(4,18)=(63.d0*c56-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
c
c Este comp. u2
c 
      ma(5,1)=-(63.d0*c12+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
     
      ma(5,2)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #        (63.d0*c26+74.d0*(c22+c66)-37.d0*c44)/63.d0*h
      
      ma(5,3)=-(63.d0*c25+74.d0*(c24+c56)-37.d0*c34)/63.d0*h
      
      ma(5,4)=(211.d0*c26+37.d0*(c16+c45))/63.d0*h     
     
      ma(5,5)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c22+37.d0*(c66+c44))/63.d0*h
       
      ma(5,6)=(211.d0*c24+37.d0*(c56+c34))/63.d0*h
       
      ma(5,7)=(85.d0*c26+37.d0*(c16+c45))/63.d0*h
      
      ma(5,8)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c22+37.d0*(c66+c44))/63.d0*h
       
      ma(5,9)=(85.d0*c24+37.d0*(c56+c34))/63.d0*h
       
      ma(5,10)=(63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
      
      ma(5,11)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c24-74.d0*(c22+c44)+37.d0*c66)/63.d0*h
       
      ma(5,12)=(63.d0*c23-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(5,13)=(-63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
      
      ma(5,14)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c24+74.d0*(c22+c44)-37.d0*c66)/63.d0*h
       
      ma(5,15)=-(63.d0*c23+74.d0*(c24+c34)-37.d0*c56)/63.d0*h       
       
      ma(5,16)=(63.d0*c12-74.d0*(c16+c26)+37.d0*c45)/63.d0*h
      
      ma(5,17)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c26-74.d0*(c22+c66)+37.d0*c44)/63.d0*h
       
      ma(5,18)=(63.d0*c25-74.d0*(c24+c56)+37.d0*c34)/63.d0*h
c
c Este comp. u3
c 
      ma(6,1)=-(63.d0*c14+74.d0*(c15+c46)-37.d0*c35)/63.d0*h
     
      ma(6,2)=-(63.d0*c46+74.d0*(c24+c56)-37.d0*c34)/63.d0*h
      
      ma(6,3)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (-63.d0*c45-74.d0*(c44+c55)+37.d0*c33)/63.d0*h
      
      ma(6,4)=(211.d0*c46+37.d0*(c35+c15))/63.d0*h     
     
      ma(6,5)=(211.d0*c24+37.d0*(c34+c56))/63.d0*h
       
      ma(6,6)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c44+37.d0*(c33+c55))/63.d0*h
       
      ma(6,7)=(85.d0*c46+37.d0*(c15+c35))/63.d0*h
      
      ma(6,8)=(85.d0*c24+37.d0*(c34+c56))/63.d0*h
       
      ma(6,9)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c44+37.d0*(c33+c55))/63.d0*h
       
      ma(6,10)=(63.d0*c45-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(6,11)=(63.d0*c44-74.d0*(c34+c24)+37.d0*c56)/63.d0*h
       
      ma(6,12)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c34-74.d0*(c33+c44)+37.d0*c55)/63.d0*h
       
      ma(6,13)=(-63.d0*c45-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(6,14)=-(63.d0*c44+74.d0*(c34+c24)-37.d0*c56)/63.d0*h
       
      ma(6,15)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c34+74.d0*(c33+c44)-37.d0*c55)/63.d0*h
       
      ma(6,16)=(63.d0*c14-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
      
      ma(6,17)=(63.d0*c46-74.d0*(c24+c56)+37.d0*c34)/63.d0*h
       
      ma(6,18)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c45-74.d0*(c44+c55)+37.d0*c33)/63.d0*h
c
c West comp. u1
c
      ma(7,1)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c16-74.d0*(c11+c66)+37.d0*c55)/63.d0*h
     
      ma(7,2)=(63.d0*c66-74.d0*(c16+c26)+37.d0*c45)/63.d0*h
      
      ma(7,3)=(63.d0*c56-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
      
      ma(7,4)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c66+37.d0*(c11+c55))/63.d0*h     
     
      ma(7,5)=(85.d0*c26+37.d0*(c16+c45))/63.d0*h 
       
      ma(7,6)=(85.d0*c46+37.d0*(c15+c35))/63.d0*h
       
      ma(7,7)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c66+37.d0*(c11+c55))/63.d0*h
      
      ma(7,8)=(211.d0*c26+37.d0*(c16+c45))/63.d0*h
       
      ma(7,9)=(211.d0*c46+37.d0*(c15+c35))/63.d0*h
       
      ma(7,10)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c56-74.d0*(c55+c66)+37.d0*c11)/63.d0*h
      
      ma(7,11)=(-63.d0*c46-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
       
      ma(7,12)=(-63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
       
      ma(7,13)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c56-74.d0*(c55+c66)+37.d0*c11)/63.d0*h
      
      ma(7,14)=(63.d0*c46-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
       
      ma(7,15)=(63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
       
      ma(7,16)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c16+74.d0*(c11+c66)-37.d0*c55)/63.d0*h
      
      ma(7,17)=-(63.d0*c66+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
       
      ma(7,18)=-(63.d0*c56+74.d0*(c46+c15)-37.d0*c35)/63.d0*h
c
c West comp. u2
c
      ma(8,1)=(63.d0*c12-74.d0*(c16+c26)+37.d0*c45)/63.d0*h 
     
      ma(8,2)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c26-74.d0*(c22+c66)+37.d0*c44)/63.d0*h
      
      ma(8,3)=(63.d0*c25-74.d0*(c24+c56)+37.d0*c34)/63.d0*h
      
      ma(8,4)=(85.d0*c26+37.d0*(c16+c45))/63.d0*h      
     
      ma(8,5)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c22+37.d0*(c66+c44))/63.d0*h
       
      ma(8,6)=(85.d0*c24+37.d0*(c56+c34))/63.d0*h
       
      ma(8,7)=(211.d0*c26+37.d0*(c16+c45))/63.d0*h
      
      ma(8,8)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c22+37.d0*(c44+c66))/63.d0*h
       
      ma(8,9)=(211.d0*c24+37.d0*(c34+c56))/63.d0*h
       
      ma(8,10)=(-63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
      
      ma(8,11)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c24+74.d0*(c22+c44)-37.d0*c66)/63.d0*h
       
      ma(8,12)=-(63.d0*c23+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(8,13)=(63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
      
      ma(8,14)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c24-74.d0*(c22+c44)+37.d0*c66)/63.d0*h
       
      ma(8,15)=(63.d0*c23-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(8,16)=-(63.d0*c12+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
      
      ma(8,17)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c26+74.d0*(c66+c22)-37.d0*c44)/63.d0*h
       
      ma(8,18)=-(63.d0*c25+74.d0*(c24+c56)-37.d0*c34)/63.d0*h
c
c West comp. u3
c
      ma(9,1)=(63.d0*c14-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
     
      ma(9,2)=(63.d0*c46-74.d0*(c24+c56)+37.d0*c34)/63.d0*h
      
      ma(9,3)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #        (63.d0*c45-74.d0*(c44+c55)+37.d0*c33)/63.d0*h 
      
      ma(9,4)=(85.d0*c46+37.d0*(c15+c35))/63.d0*h     
     
      ma(9,5)=(85.d0*c24+37.d0*(c34+c56))/63.d0*h
       
      ma(9,6)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #        (85.d0*c44+37.d0*(c33+c55))/63.d0*h
       
      ma(9,7)=(211.d0*c46+37.d0*(c15+c35))/63.d0*h
      
      ma(9,8)=(211.d0*c24+37.d0*(c34+c56))/63.d0*h
       
      ma(9,9)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c44+37.d0*(c33+c55))/63.d0*h
       
      ma(9,10)=(-63.d0*c45-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(9,11)=-(63.d0*c44+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(9,12)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c34+74.d0*(c44+c33)-37.d0*c55)/63.d0*h
       
      ma(9,13)=(63.d0*c45-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(9,14)=(63.d0*c44-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(9,15)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c34-74.d0*(c44+c33)+37.d0*c55)/63.d0*h
       
      ma(9,16)=-(63.d0*c14+74.d0*(c15+c46)-37.d0*c35)/63.d0*h
      
      ma(9,17)=-(63.d0*c46+74.d0*(c24+c56)-37.d0*c34)/63.d0*h
      
      ma(9,18)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c45-74.d0*(c55+c44)+37.d0*c33)/63.d0*h
c
c Norte comp. u1
c
      ma(10,1)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c15+74.d0*(c11+c55)-37.d0*c66)/63.d0*h
     
      ma(10,2)=-(63.d0*c56+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
      
      ma(10,3)=-(63.d0*c55+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
      
      ma(10,4)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c56-74.d0*(c66+c55)+37.d0*c11)/63.d0*h     
     
      ma(10,5)=(63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
       
      ma(10,6)=(63.d0*c45-74.d0*(c46+c35)+37.d0*c15)/63.d0*h
       
      ma(10,7)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c56-74.d0*(c55+c66)+37.d0*c11)/63.d0*h
      
      ma(10,8)=(-63.d0*c25-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
       
      ma(10,9)=(-63.d0*c45-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
       
      ma(10,10)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c55+37.d0*(c11+c66))/63.d0*h
      
      ma(10,11)=(211.d0*c45+37.d0*(c16+c26))/63.d0*h
       
      ma(10,12)=(211.d0*c35+37.d0*(c15+c46))/63.d0*h
       
      ma(10,13)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c55+37.d0*(c11+c66))/63.d0*h
      
      ma(10,14)=(85.d0*c45+37.d0*(c16+c26))/63.d0*h
       
      ma(10,15)=(85.d0*c35+37.d0*(c15+c46))/63.d0*h
       
      ma(10,16)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c15-74.d0*(c11+c55)+37.d0*c66)/63.d0*h
      
      ma(10,17)=(63.d0*c56-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
       
      ma(10,18)=(63.d0*c55-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
c
c Norte comp. u2
c
      ma(11,1)=-(63.d0*c14+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
     
      ma(11,2)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c46-74.d0*(c44+c66)+37.d0*c22)/63.d0*h
      
      ma(11,3)=(-63.d0*c45-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
      
      ma(11,4)=(63.d0*c46-74.d0*(c26+c45)+37.d0*c16)/63.d0*h     
     
      ma(11,5)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c24-74.d0*(c22+c44)+37.d0*c66)/63.d0*h
       
      ma(11,6)=(63.d0*c44-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(11,7)=(-63.d0*c46-74.d0*(c45+c26)+37.d0*c16)/63.d0*h
      
      ma(11,8)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c24+74.d0*(c22+c44)-37.d0*c66)/63.d0*h 
       
      ma(11,9)=-(63.d0*c44+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(11,10)=(211.d0*c45+37.d0*(c16+c26))/63.d0*h
      
      ma(11,11)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c44+37.d0*(c22+c66))/63.d0*h
       
      ma(11,12)=(211.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(11,13)=(85.d0*c45+37.d0*(c16+c26))/63.d0*h
      
      ma(11,14)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c44+37.d0*(c66+c22))/63.d0*h
       
      ma(11,15)=(85.d0*c34+37.d0*(c56+c24))/63.d0*h
       
      ma(11,16)=(63.d0*c14-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
      
      ma(11,17)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
       
      ma(11,18)=(63.d0*c45-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
c
c Norte comp. u3
c
      ma(12,1)=-(63.d0*c13+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
     
      ma(12,2)=(-63.d0*c36-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
      
      ma(12,3)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c35+74.d0*(c55+c33)-37.d0*c44)/63.d0*h 
      
      ma(12,4)=(63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h     
     
      ma(12,5)=(63.d0*c23-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(12,6)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c34-74.d0*(c33+c44)+37.d0*c55)/63.d0*h 
       
      ma(12,7)=(-63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(12,8)=-(63.d0*c23+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(12,9)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c34+74.d0*(c33+c44)-37.d0*c55)/63.d0*h 
       
      ma(12,10)=(211.d0*c35+37.d0*(c15+c46))/63.d0*h
      
      ma(12,11)=(211.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(12,12)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c33+37.d0*(c44+c55))/63.d0*h
       
      ma(12,13)=(85.d0*c35+37.d0*(c15+c46))/63.d0*h
      
      ma(12,14)=(85.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(12,15)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c33+37.d0*(c44+c55))/63.d0*h
       
      ma(12,16)=(63.d0*c13-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
      
      ma(12,17)=(63.d0*c36-74.d0*(c34+c56)+37.d0*c24)/63.d0*h 
       
      ma(12,18)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c35-74.d0*(c33+c55)+37.d0*c44)/63.d0*h
c
c Sur comp. u1
c
      ma(13,1)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c15-74.d0*(c11+c55)+37.d0*c66)/63.d0*h 
     
      ma(13,2)=(63.d0*c56-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
      
      ma(13,3)=(63.d0*c55-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
      
      ma(13,4)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c56-74.d0*(c66+c55)+37.d0*c11)/63.d0*h      
     
      ma(13,5)=(-63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
       
      ma(13,6)=(-63.d0*c45-74.d0*(c46+c35)+37.d0*c15)/63.d0*h
       
      ma(13,7)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c56-74.d0*(c66+c55)+37.d0*c11)/63.d0*h 
      
      ma(13,8)=(63.d0*c25-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
       
      ma(13,9)=(63.d0*c45-74.d0*(c46+c35)+37.d0*c15)/63.d0*h
       
      ma(13,10)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c55+37.d0*(c11+c66))/63.d0*h
      
      ma(13,11)=(85.d0*c45+37.d0*(c16+c26))/63.d0*h
       
      ma(13,12)=(85.d0*c35+37.d0*(c15+c46))/63.d0*h
       
      ma(13,13)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c55+37.d0*(c11+c66))/63.d0*h
      
      ma(13,14)=(211.d0*c45+37.d0*(c16+c26))/63.d0*h
       
      ma(13,15)=(211.d0*c35+37.d0*(c15+c46))/63.d0*h
       
      ma(13,16)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #          (63.d0*c15+74.d0*(c11+c55)-37.d0*c66)/63.d0*h
      
      ma(13,17)=-(63.d0*c56+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
       
      ma(13,18)=-(63.d0*c55+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
c
c Sur comp. u2
c
      ma(14,1)=(63.d0*c14-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
     
      ma(14,2)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h 
      
      ma(14,3)=(63.d0*c45-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
      
      ma(14,4)=(-63.d0*c46-74.d0*(c26+c45)+37.d0*c16)/63.d0*h     
     
      ma(14,5)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c24+74.d0*(c22+c44)-37.d0*c66)/63.d0*h 
       
      ma(14,6)=-(63.d0*c44+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(14,7)=(63.d0*c46-74.d0*(c26+c45)+37.d0*c16)/63.d0*h
      
      ma(14,8)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c24-74.d0*(c22+c44)+37.d0*c66)/63.d0*h 
       
      ma(14,9)=(63.d0*c44-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(14,10)=(85.d0*c45+37.d0*(c16+c26))/63.d0*h
      
      ma(14,11)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c44+37.d0*(c66+c22))/63.d0*h
       
      ma(14,12)=(85.d0*c34+37.d0*(c56+c24))/63.d0*h
       
      ma(14,13)=(211.d0*c45+37.d0*(c16+c26))/63.d0*h
      
      ma(14,14)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c44+37.d0*(c22+c66))/63.d0*h
       
      ma(14,15)=(211.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(14,16)=-(63.d0*c14+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
      
      ma(14,17)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (-63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
       
      ma(14,18)=(-63.d0*c45-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
c
c Sur comp. u3
c
      ma(15,1)=(63.d0*c13-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
     
      ma(15,2)=(63.d0*c36-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
      
      ma(15,3)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c35-74.d0*(c33+c55)+37.d0*c44)/63.d0*h 
      
      ma(15,4)=(-63.d0*c36-74.d0*(c46+c35)+37.d0*c15)/63.d0*h     
     
      ma(15,5)=-(63.d0*c23+74.d0*(c24+c34)-37.d0*c56)/63.d0*h
       
      ma(15,6)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c34+74.d0*(c44+c33)-37.d0*c55)/63.d0*h 
       
      ma(15,7)=(63.d0*c36-74.d0*(c35+c46)+37.d0*c15)/63.d0*h
      
      ma(15,8)=(63.d0*c23-74.d0*(c24+c34)+37.d0*c56)/63.d0*h
       
      ma(15,9)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c34-74.d0*(c44+c33)+37.d0*c55)/63.d0*h 
       
      ma(15,10)=(85.d0*c35+37.d0*(c15+c46))/63.d0*h
      
      ma(15,11)=(85.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(15,12)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #          (85.d0*c33+37.d0*(c44+c55))/63.d0*h
       
      ma(15,13)=(211.d0*c35+37.d0*(c15+c46))/63.d0*h
      
      ma(15,14)=(211.d0*c34+37.d0*(c24+c56))/63.d0*h
       
      ma(15,15)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c33+37.d0*(c44+c55))/63.d0*h
       
      ma(15,16)=-(63.d0*c13+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
      
      ma(15,17)=(-63.d0*c36-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
       
      ma(15,18)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #          (63.d0*c35+74.d0*(c55+c33)-37.d0*c44)/63.d0*h
c
c Front comp. u1
c
      ma(16,1)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #         (85.d0*c11+37.d0*(c66+c55))/63.d0*h 
     
      ma(16,2)=(85.d0*c16+37.d0*(c26+c45))/63.d0*h
      
      ma(16,3)=(85.d0*c15+37.d0*(c46+c35))/63.d0*h
      
      ma(16,4)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c16-74.d0*(c11+c66)+37.d0*c55)/63.d0*h     
     
      ma(16,5)=(63.d0*c12-74.d0*(c16+c26)+37.d0*c45)/63.d0*h
       
      ma(16,6)=(63.d0*c14-74.d0*(c15+c46)+37.d0*c35)/63.d0*h
       
      ma(16,7)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c16+74.d0*(c11+c66)-37.d0*c55)/63.d0*h
      
      ma(16,8)=-(63.d0*c12+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
       
      ma(16,9)=-(63.d0*c14+74.d0*(c15+c46)-37.d0*c35)/63.d0*h
      
      ma(16,10)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c15-74.d0*(c11+c55)+37.d0*c66)/63.d0*h
      
      ma(16,11)=(63.d0*c14-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
       
      ma(16,12)=(63.d0*c13-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
       
      ma(16,13)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #          (63.d0*c15+74.d0*(c11+c55)-37.d0*c66)/63.d0*h
      
      ma(16,14)=-(63.d0*c14+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
       
      ma(16,15)=-(63.d0*c13+74.d0*(c35+c15)-37.d0*c46)/63.d0*h
       
      ma(16,16)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c11+37.d0*(c66+c55))/63.d0*h
      
      ma(16,17)=(211.d0*c16+37.d0*(c26+c45))/63.d0*h
       
      ma(16,18)=(211.d0*c15+37.d0*(c46+c35))/63.d0*h
c
c Front comp. u2
c
      ma(17,1)=(85.d0*c16+37.d0*(c26+c45))/63.d0*h
     
      ma(17,2)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #         (85.d0*c66+37.d0*(c22+c44))/63.d0*h
      
      ma(17,3)=(85.d0*c56+37.d0*(c24+c34))/63.d0*h
      
      ma(17,4)=(63.d0*c66-74.d0*(c16+c26)+37.d0*c45)/63.d0*h     
     
      ma(17,5)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c26-74.d0*(c66+c22)+37.d0*c44)/63.d0*h 
       
      ma(17,6)=(63.d0*c46-74.d0*(c56+c24)+37.d0*c34)/63.d0*h
       
      ma(17,7)=-(63.d0*c66+74.d0*(c16+c26)-37.d0*c45)/63.d0*h
      
      ma(17,8)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #         (63.d0*c26+74.d0*(c66+c22)-37.d0*c44)/63.d0*h 
       
      ma(17,9)=-(63.d0*c46+74.d0*(c56+c24)-37.d0*c34)/63.d0*h
       
      ma(17,10)=(63.d0*c56-74.d0*(c16+c45)+37.d0*c26)/63.d0*h
      
      ma(17,11)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
       
      ma(17,12)=(63.d0*c36-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
       
      ma(17,13)=-(63.d0*c56+74.d0*(c16+c45)-37.d0*c26)/63.d0*h
      
      ma(17,14)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (-63.d0*c46-74.d0*(c66+c44)+37.d0*c22)/63.d0*h
       
      ma(17,15)=(-63.d0*c36-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
       
      ma(17,16)=(211.d0*c16+37.d0*(c26+c45))/63.d0*h
      
      ma(17,17)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c66+37.d0*(c22+c44))/63.d0*h
       
      ma(17,18)=(211.d0*c56+37.d0*(c24+c34))/63.d0*h
c
c Front comp. u3
c
      ma(18,1)=(85.d0*c15+37.d0*(c35+c46))/63.d0*h
     
      ma(18,2)=(85.d0*c56+37.d0*(c34+c24))/63.d0*h
      
      ma(18,3)=-rho*omega*omega*hhh*(-82.d0)/1890.d0 +
     #         (85.d0*c55+37.d0*(c33+c44))/63.d0*h
      
      ma(18,4)=(63.d0*c56-74.d0*(c15+c46)+37.d0*c35)/63.d0*h     
     
      ma(18,5)=(63.d0*c25-74.d0*(c56+c24)+37.d0*c34)/63.d0*h
       
      ma(18,6)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (63.d0*c45-74.d0*(c55+c44)+37.d0*c33)/63.d0*h 
       
      ma(18,7)=-(63.d0*c56+74.d0*(c46+c15)-37.d0*c35)/63.d0*h
      
      ma(18,8)=-(63.d0*c25+74.d0*(c56+c24)-37.d0*c34)/63.d0*h
       
      ma(18,9)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #         (-63.d0*c45-74.d0*(c55+c44)+37.d0*c33)/63.d0*h 
       
      ma(18,10)=(63.d0*c55-74.d0*(c15+c35)+37.d0*c46)/63.d0*h
      
      ma(18,11)=(63.d0*c45-74.d0*(c34+c56)+37.d0*c24)/63.d0*h
       
      ma(18,12)=-rho*omega*omega*hhh*41.d0/1890.d0 +
     #          (63.d0*c35-74.d0*(c33+c55)+37.d0*c44)/63.d0*h
       
      ma(18,13)=-(63.d0*c55+74.d0*(c15+c35)-37.d0*c46)/63.d0*h
      
      ma(18,14)=(-63.d0*c45-74.d0*(c56+c34)+37.d0*c24)/63.d0*h
       
      ma(18,15)=-rho*omega*omega*hhh*41.d0/1890.d0 -
     #          (63.d0*c35+74.d0*(c55+c33)-37.d0*c44)/63.d0*h
       
      ma(18,16)=(211.d0*c15+37.d0*(c35+c46))/63.d0*h
      
      ma(18,17)=(211.d0*c56+37.d0*(c34+c24))/63.d0*h
       
      ma(18,18)=-rho*omega*omega*hhh*233.d0/1890.d0 +
     #        (211.d0*c55+37.d0*(c33+c44))/63.d0*h
c
c   Fills the rest of matrix  ma  by symmetry      

c      do x=2,18
c       do y=1,x-1
c        ma(x,y)=ma(y,x)
c       enddo
c      enddo

c     computes 
c     Robin transmission coefficients betai, i=f,e,n,b,w,s
c     for the current element (j,k,l)
	 
c    gets  absorbing  b. C. coefficient

c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta1b =  avrho*avvp*facbeta*omega	

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta2b =  avrho*avvs1*facbeta*omega

c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta3b =  avrho*avvs2*facbeta*omega	

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta1e =  avrho*avvs1*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta2e =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta3e =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta1w =  avrho*avvs1*facbeta*omega
 
         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta2w =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta3w =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta1n =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta2n =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta3n =  avrho*avvp*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta1s =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta2s =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta3s =  avrho*avvp*facbeta*omega

c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta1f =  avrho*avvp*facbeta*omega

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta2f =  avrho*avvs1*facbeta*omega
	 
c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta3f =  avrho*avvs2*facbeta*omega

         rhonx=rhomat(matnum(nx,k,l))
         rho1x=rhomat(matnum(1,k,l))

         rhony=rhomat(matnum(j,ny,l))
         rho1y=rhomat(matnum(j,1,l))

         rhonz=rhomat(matnum(j,k,nz))
         rho1z=rhomat(matnum(j,k,1))

      c11nx=dsqrt(rhonx)*dsqrt(dreal(c11mat(matnum(nx,k,l),jw)))
      c111x=dsqrt(rho1x)*dsqrt(dreal(c11mat(matnum(1,k,l),jw)))

      c22ny=dsqrt(rhony)*dsqrt(dreal(c22mat(matnum(j,ny,l),jw)))
      c221y=dsqrt(rho1y)*dsqrt(dreal(c22mat(matnum(j,1,l),jw)))

      c66ny=dsqrt(rhony)*dsqrt(dreal(c66mat(matnum(j,ny,l),jw)))
      c661y=dsqrt(rho1y)*dsqrt(dreal(c66mat(matnum(j,1,l),jw)))

      c44nz=dsqrt(rhonz)*dsqrt(dreal(c44mat(matnum(j,k,nz),jw)))
      c441z=dsqrt(rho1z)*dsqrt(dreal(c44mat(matnum(j,k,1),jw)))

      c55nz=dsqrt(rhonz)*dsqrt(dreal(c55mat(matnum(j,k,nz),jw)))
      c551z=dsqrt(rho1z)*dsqrt(dreal(c55mat(matnum(j,k,1),jw)))

      c66nx=dsqrt(rhonx)*dsqrt(dreal(c66mat(matnum(nx,k,l),jw)))
      c661x=dsqrt(rho1x)*dsqrt(dreal(c66mat(matnum(1,k,l),jw)))

      c11ny=dsqrt(rhony)*dsqrt(dreal(c11mat(matnum(j,ny,l),jw)))
      c111y=dsqrt(rho1y)*dsqrt(dreal(c11mat(matnum(j,1,l),jw)))

      c55nx=dsqrt(rhonx)*dsqrt(dreal(c55mat(matnum(nx,k,l),jw)))
      c551x=dsqrt(rho1x)*dsqrt(dreal(c55mat(matnum(1,k,l),jw)))

      c44nx=dsqrt(rhonx)*dsqrt(dreal(c44mat(matnum(nx,k,l),jw)))
      c441x=dsqrt(rho1x)*dsqrt(dreal(c44mat(matnum(1,k,l),jw)))

      c44ny=dsqrt(rhony)*dsqrt(dreal(c44mat(matnum(j,ny,l),jw)))
      c441y=dsqrt(rho1y)*dsqrt(dreal(c44mat(matnum(j,1,l),jw)))

      c33nz=dsqrt(rhonz)*dsqrt(dreal(c33mat(matnum(j,k,nz),jw)))
      c331z=dsqrt(rho1z)*dsqrt(dreal(c33mat(matnum(j,k,1),jw)))
c
c   Aca estan los bordes agregados a la diag ppal.
c        
      ma(1,1)= ma(1,1)+ aim* omega* hh* deltab(j)* c111x
c     1           + aim* hh* beta1b* (1.d0- deltab(j))

      ma(2,2)= ma(2,2)+ aim* omega* hh* deltab(j)* c661x
c     1           + aim* hh* beta2b* (1.d0- deltab(j))

      ma(3,3)= ma(3,3)+ aim* omega* hh* deltab(j)*c551x
c     1           + aim* hh* beta3b* (1.d0- deltab(j))

      ma(4,4)= ma(4,4)+ aim* omega* hh* deltae(k)* c66ny
     1           + aim* hh* beta1e* (1.d0- deltae(k))

      ma(5,5)= ma(5,5)+ aim* omega* hh* deltae(k)* c22ny
     1           + aim* hh* beta2e* (1.d0- deltae(k))

      ma(6,6)= ma(6,6)+ aim* omega* hh* deltae(k)*c44ny
     1           + aim* hh* beta3e* (1.d0- deltae(k))

      ma(7,7)= ma(7,7)+ aim* omega* hh* deltaw(k)* c661y
     1           + aim* hh* beta1w* (1.d0- deltaw(k))

      ma(8,8)= ma(8,8)+ aim* omega* hh* deltaw(k)*c221y
     1           + aim* hh* beta2w* (1.d0- deltaw(k))

      ma(9,9)= ma(9,9)+ aim* omega* hh* deltaw(k)*c441y
     1           + aim* hh* beta3w* (1.d0- deltaw(k))

      ma(10,10)= ma(10,10)+ aim* omega* hh* deltan(l)*c55nz
     1           + aim* hh* beta1n* (1.d0- deltan(l))

      ma(11,11)= ma(11,11)+ aim* omega* hh* deltan(l)*c44nz
     1           + aim* hh* beta2n* (1.d0- deltan(l))

      ma(12,12)= ma(12,12)+ aim* omega* hh* deltan(l)*c33nz
     1           + aim* hh* beta3n* (1.d0- deltan(l))

      ma(13,13)= ma(13,13)+ aim* omega* hh* deltas(l)*c551z
     1           + aim* hh* beta1s* (1.d0- deltas(l))

      ma(14,14)= ma(14,14)+ aim* omega* hh* deltas(l)*c441z
     1           + aim* hh* beta2s* (1.d0- deltas(l))

      ma(15,15)= ma(15,15)+ aim* omega* hh* deltas(l)*c331z
     1           + aim* hh* beta3s* (1.d0- deltas(l))

      ma(16,16)= ma(16,16)+ aim* omega* hh* deltaf(j)*c11nx
c     1           + aim* hh* beta1f* (1.d0- deltaf(j))

      ma(17,17)= ma(17,17)+ aim* omega* hh* deltaf(j)*c66nx
c     1           + aim* hh* beta2f* (1.d0- deltaf(j))

      ma(18,18)= ma(18,18)+ aim* omega* hh* deltaf(j)*c55nx
c     1           + aim* hh* beta3f* (1.d0- deltaf(j))

c
            do 10 mm=1,18
*  ir = row  number of global matrix
         ir =  ngnod(j,mm)
            do 10 nn=1,18
* ic = column number of global matrix
         ic = ngnod(j,nn)
         if(ir.eq.ic) then
         a(ir,18,k,l) = a(ir,18,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+1) then
         a(ir,19,k,l) = a(ir,19,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+2) then
         a(ir,20,k,l) = a(ir,20,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+3) then
         a(ir,21,k,l) = a(ir,21,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+4) then
         a(ir,22,k,l) = a(ir,22,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+5) then
         a(ir,23,k,l) = a(ir,23,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+6) then
         a(ir,24,k,l) = a(ir,24,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+7) then
         a(ir,25,k,l) = a(ir,25,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+8) then
         a(ir,26,k,l) = a(ir,26,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+9) then
         a(ir,27,k,l) = a(ir,27,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+10) then
         a(ir,28,k,l) = a(ir,28,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+11) then
         a(ir,29,k,l) = a(ir,29,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+12) then
         a(ir,30,k,l) = a(ir,30,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+13) then
         a(ir,31,k,l) = a(ir,31,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+14) then
         a(ir,32,k,l) = a(ir,32,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+15) then
         a(ir,33,k,l) = a(ir,33,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+16) then
         a(ir,34,k,l) = a(ir,34,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir+17) then
         a(ir,35,k,l) = a(ir,35,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-1) then
         a(ir,17,k,l) = a(ir,17,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-2) then
         a(ir,16,k,l) = a(ir,16,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-3) then
         a(ir,15,k,l) = a(ir,15,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-4) then
         a(ir,14,k,l) = a(ir,14,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-5) then
         a(ir,13,k,l) = a(ir,13,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-6) then
         a(ir,12,k,l) = a(ir,12,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-7) then
         a(ir,11,k,l) = a(ir,11,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-8) then
         a(ir,10,k,l) = a(ir,10,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-9) then
         a(ir,9,k,l) = a(ir,9,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-10) then
         a(ir,8,k,l) = a(ir,8,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-11) then
         a(ir,7,k,l) = a(ir,7,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-12) then
         a(ir,6,k,l) = a(ir,6,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-13) then
         a(ir,5,k,l) = a(ir,5,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-14) then
         a(ir,4,k,l) = a(ir,4,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-15) then
         a(ir,3,k,l) = a(ir,3,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-16) then
         a(ir,2,k,l) = a(ir,2,k,l) + ma(mm,nn)
          endif
         if(ic.eq.ir-17) then
         a(ir,1,k,l) = a(ir,1,k,l) + ma(mm,nn)
          endif
10       continue
              
1003     continue

         do jj=1,15*nx+3
           do jx=1,18
             a(jj,jx,k,l)=a(jj,18+jx-1,k,l)
           enddo
         enddo

      call banda(kk,ll)

      return
      end
************************************************************************
      subroutine rhssolve(ll,kk)
       implicit none
      include 'commons.aniso'
      complex*16 aim,rb(18),sol(nunk)
      integer jj1,i,mm,ir,jhx,kk,ll,x,j,k,l,y,z,ik,il
      real*8 sourfx, sourex, sournx, sourbx, sourwx, soursx, 
     1 sourfy, sourey, sourny, sourby, sourwy, soursy,
     1 sourfz, sourez, sournz, sourbz, sourwz, soursz
      real*8 avvp,avvs1,avvs2,avrho,facbeta,posy,posz,auxy,auxz
      real*8 rhokm1,rhokp1,rholm1,rholp1,rhojm1,rhojp1
      complex*16 c11,c12,c13,c14,c15,c16,c22,c23,c24,c25,c26
      complex*16 c33,c34,c35,c36,c44,c45,c46,c55,c56,c66
      complex*16 c11km1,c11kp1,c66km1,c66kp1
      complex*16 c44lm1,c44lp1,c44km1,c44kp1
      complex*16 c33lm1,c33lp1
      complex*16 c22km1,c22kp1,c55lm1,c55lp1

      aim=dcmplx(0.d0,1.d0)
      facbeta=1.d0
      k=kk
      l=ll
****
         do jj1=1,15*nx+3
          b(jj1) = dcmplx(0.d0,0.d0)
         enddo
****   
c
c CALCULO DEL RHS
c  
c
c  computes Global position  coordinate in the  y-direction
c
          posy = vblockid(1)*hpy + (k-1)*h +.5d0*h
c
c  computes Global position  coordinate in the  z-direction
c
          posz = ((nsz-1)-vblockid(2))*hpz+ (l-1)*h + 0.5d0*h

	  auxy = posy/h +1.d0
          auxz = posz/h +1.d0

	  ik =int(auxy)
          il =int(auxz)

          do 1041 j=1,nx

       i = matnum(j,ik,il)
       c11=c11mat(i,jw)
       c12=c12mat(i,jw)
       c13=c13mat(i,jw)
       c14=c14mat(i,jw)
       c15=c15mat(i,jw)  
       c16=c16mat(i,jw)
       c22=c22mat(i,jw)
       c23=c23mat(i,jw)
       c24=c24mat(i,jw)
       c25=c25mat(i,jw)
       c26=c26mat(i,jw)
       c33=c33mat(i,jw)
       c34=c34mat(i,jw)
       c35=c35mat(i,jw)
       c36=c36mat(i,jw)   
       c44=c44mat(i,jw)
       c45=c45mat(i,jw)
       c46=c46mat(i,jw)
       c55=c55mat(i,jw)
       c56=c56mat(i,jw)
       c66=c66mat(i,jw)
       rho=rhomat(i)   

c       i = matnum(j-1,ik,il)
c       c11jm1=c11mat(i)
c       c55jm1=c55mat(i)
c       c66jm1=c66mat(i)
c       rhojm1=rhomat(i)

c       i = matnum(j+1,ik,il)
c       c11jp1=c11mat(i)
c       c55jp1=c55mat(i)
c       c66jp1=c66mat(i)
c       rhojp1=rhomat(i)

       i = matnum(j,ik-1,il)
       c22km1=c22mat(i,jw)
       c44km1=c44mat(i,jw)
       c66km1=c66mat(i,jw)
       rhokm1=rhomat(i)

       i = matnum(j,ik+1,il)
       c22kp1=c22mat(i,jw)
       c44kp1=c44mat(i,jw)
       c66kp1=c66mat(i,jw)
       rhokp1=rhomat(i)

       i = matnum(j,ik,il-1)
       c33lm1=c33mat(i,jw)
       c44lm1=c44mat(i,jw)
       c55lm1=c55mat(i,jw)
       rholm1=rhomat(i)
      
       i = matnum(j,ik,il+1)
       c33lp1=c33mat(i,jw)
       c44lp1=c44mat(i,jw)
       c55lp1=c55mat(i,jw)
       rholp1=rhomat(i)

c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta1b =  avrho*avvp*facbeta*omega	

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta2b =  avrho*avvs1*facbeta*omega

c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta3b =  avrho*avvs2*facbeta*omega	

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta1e =  avrho*avvs1*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta2e =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta3e =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta1w =  avrho*avvs1*facbeta*omega
 
         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta2w =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta3w =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta1n =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta2n =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta3n =  avrho*avvp*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta1s =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta2s =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta3s =  avrho*avvp*facbeta*omega

c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta1f =  avrho*avvp*facbeta*omega

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta2f =  avrho*avvs1*facbeta*omega
	 
c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta3f =  avrho*avvs2*facbeta*omega

       rb(1) = dcmplx(0.d0,0.d0)

       rb(2) = dcmplx(0.d0,0.d0)

       rb(3) = dcmplx(0.d0,0.d0)

       rb(4) = hh*(1.d0 - deltae(k) )*( lag1w(j,k+1,l)
     1                +aim * beta1e* u1w(j,k+1,l) )

       rb(5) = hh*(1.d0 - deltae(k) )*( lag2w(j,k+1,l)
     1                +aim * beta2e* u2w(j,k+1,l) )

       rb(6) = hh*(1.d0 - deltae(k) )*( lag3w(j,k+1,l)
     1                +aim * beta3e* u3w(j,k+1,l) )

       rb(7) = hh*(1.d0 - deltaw(k) )*( lag1e(j,k-1,l)
     1                +aim * beta1w* u1e(j,k-1,l) )

      rb(8) = hh*(1.d0 - deltaw(k) )*( lag2e(j,k-1,l)
     1                +aim * beta2w* u2e(j,k-1,l) )

      rb(9) = hh*(1.d0 - deltaw(k) )*( lag3e(j,k-1,l)
     1                +aim * beta3w* u3e(j,k-1,l) )

      rb(10) = hh*(1.d0 - deltan(l) )*( lag1s(j,k,l+1)
     1                +aim * beta1n* u1s(j,k,l+1) )

      rb(11) = hh*(1.d0 - deltan(l) )*( lag2s(j,k,l+1)
     1                +aim * beta2n* u2s(j,k,l+1) )

      rb(12) = hh*(1.d0 - deltan(l) )*( lag3s(j,k,l+1)
     1                +aim * beta3n* u3s(j,k,l+1) )

      rb(13) = hh*(1.d0 - deltas(l) )*( lag1n(j,k,l-1)
     1                +aim * beta1s* u1n(j,k,l-1) )

      rb(14) = hh*(1.d0 - deltas(l) )*( lag2n(j,k,l-1)
     1                +aim * beta2s* u2n(j,k,l-1) )    

      rb(15) = hh*(1.d0 - deltas(l) )*( lag3n(j,k,l-1)
     1                +aim * beta3s* u3n(j,k,l-1) )   

       rb(16) = dcmplx(0.d0,0.d0)
     
       rb(17) = dcmplx(0.d0,0.d0)

       rb(18) = dcmplx(0.d0,0.d0)

       if(blockid.eq.isourid) then
            if(j.eq.jsou.and.k.eq.ksou.and.l.eq.lsou) then

       i = matnum(j,ik,il)
       rho=rhomat(i)
c
c Gradiente de la delta
c
c      rb(1)=rb(1) - sourbx(srx)*fsour(jw)*rho
c      rb(2)=rb(2) - sourby(sry)*fsour(jw)*rho
c      rb(3)=rb(3) - sourbz(srz)*fsour(jw)*rho
c      rb(4)=rb(4) - sourex(srx)*fsour(jw)*rho
c      rb(5)=rb(5) - sourey(sry)*fsour(jw)*rho
c      rb(6)=rb(6) - sourez(srz)*fsour(jw)*rho
c      rb(7)=rb(7) - sourwx(srx)*fsour(jw)*rho
c      rb(8)=rb(8) - sourwy(sry)*fsour(jw)*rho
c      rb(9)=rb(9) - sourwz(srz)*fsour(jw)*rho
c      rb(10)=rb(10) - sournx(srx)*fsour(jw)*rho
c      rb(11)=rb(11) - sourny(sry)*fsour(jw)*rho
c      rb(12)=rb(12) - sournz(srz)*fsour(jw)*rho
c      rb(13)=rb(13) - soursx(srx)*fsour(jw)*rho
c      rb(14)=rb(14) - soursy(sry)*fsour(jw)*rho
c      rb(15)=rb(15) - soursz(srz)*fsour(jw)*rho
c      rb(16)=rb(16) - sourfx(srx)*fsour(jw)*rho
c      rb(17)=rb(17) - sourfy(sry)*fsour(jw)*rho
c      rb(18)=rb(18) - sourfz(srz)*fsour(jw)*rho
c
c Divergencia
c
      rb(1)=rb(1) - fsour(jw)*rho/h
      rb(2)=rb(2)
      rb(3)=rb(3) 
      rb(4)=rb(4) 
      rb(5)=rb(5) + fsour(jw)*rho/h
      rb(6)=rb(6) 
      rb(7)=rb(7) 
      rb(8)=rb(8) - fsour(jw)*rho/h
      rb(9)=rb(9)
      rb(10)=rb(10)
      rb(11)=rb(11) 
      rb(12)=rb(12) + fsour(jw)*rho/h
      rb(13)=rb(13) 
      rb(14)=rb(14)
      rb(15)=rb(15) - fsour(jw)*rho/h
      rb(16)=rb(16) + fsour(jw)*rho/h
      rb(17)=rb(17)
      rb(18)=rb(18)
c
c rotor
c
c      rb(1)=rb(1) 
c      rb(2)=rb(2) - fsour(jw)*rho/h
c      rb(3)=rb(3) + fsour(jw)*rho/h
c      rb(4)=rb(4) + fsour(jw)*rho/h
c      rb(5)=rb(5) 
c      rb(6)=rb(6) + fsour(jw)*rho/h
c      rb(7)=rb(7) + fsour(jw)*rho/h
c      rb(8)=rb(8) 
c      rb(9)=rb(9) - fsour(jw)*rho/h
c      rb(10)=rb(10) + fsour(jw)*rho/h
c      rb(11)=rb(11) - fsour(jw)*rho/h
c      rb(12)=rb(12) 
c      rb(13)=rb(13) - fsour(jw)*rho/h
c      rb(14)=rb(14) + fsour(jw)*rho/h
c      rb(15)=rb(15) 
c      rb(16)=rb(16) 
c      rb(17)=rb(17) + fsour(jw)*rho/h
c      rb(18)=rb(18) - fsour(jw)*rho/h
c
c Fuente para comparar con solucion analitica
c         rb(12)=rb(12)- sournz(srz)*fsour(jw)*rho*1.d+3/h
c         rb(15)=rb(15)+ soursz(srz)*fsour(jw)*rho*1.d+3/h
ccc
c          do jhx=1,18
c             rb(jhx)=rb(jhx)+(1.d12,1.d12)
c            write(101,*) 'n-rhs(n)=',jhx,rb(jhx)
c          enddo
c        stop 77665
ccc
             endif
       endif
            do 10 mm=1,18
         ir =  ngnod(j,mm)
          b(ir) = b(ir) + rb(mm)
10       continue

1041     continue

      call rhsb(sol,kk,ll)

       do x=1,nx
       u1b(x,k,l)= sol(15*(x-1)+1)
       u2b(x,k,l)= sol(15*(x-1)+2)
       u3b(x,k,l)= sol(15*(x-1)+3)
       u1e(x,k,l)= sol(15*(x-1)+4)
       u2e(x,k,l)= sol(15*(x-1)+5)
       u3e(x,k,l)= sol(15*(x-1)+6)
       u1w(x,k,l)= sol(15*(x-1)+7)
       u2w(x,k,l)= sol(15*(x-1)+8)
       u3w(x,k,l)= sol(15*(x-1)+9)
       u1n(x,k,l)= sol(15*(x-1)+10)       
       u2n(x,k,l)= sol(15*(x-1)+11)
       u3n(x,k,l)= sol(15*(x-1)+12)
       u1s(x,k,l)= sol(15*(x-1)+13)
       u2s(x,k,l)= sol(15*(x-1)+14)
       u3s(x,k,l)= sol(15*(x-1)+15)        
       u1f(x,k,l)= sol(15*(x-1)+16)
       u2f(x,k,l)= sol(15*(x-1)+17)
       u3f(x,k,l)= sol(15*(x-1)+18)
       enddo

       return 
       end 
********************************************************************************
c
c    Funciones para armar la fuente sour.. 
c    C/ funcion es la derivada de la funcion de prueba correspondiente.
c    La sourfx es la dff/dx, la sourn2 seria dfn/dy, etc
c
********************************************************************************
      function sourfx(x)  
       implicit none
      include 'commons.aniso'
      real *8 sourfx, x

       sourfx=1.d0/h + ((-4.d0*(-1.d0 + (2.d0*x)/h))/h + 
     1       (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/2.d0
                                 
      return
      end
***********************************************************************
      function sourex(x)
       implicit none
      include 'commons.aniso'
      real *8 sourex, x

      sourex=((4.d0*(-1.d0 + (2.d0*x)/h))/h - 
     1        (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sournx(x)
       implicit none
      include 'commons.aniso'
      real *8 sournx, x

      sournx=((4.d0*(-1.d0 + (2.d0*x)/h))/h - 
     1        (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sourbx(x)
       implicit none
      include 'commons.aniso'
      real *8 sourbx, x

      sourbx=-(1.d0/h) + ((-4.d0*(-1.d0 + (2.d0*x)/h))/h + 
     1          (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/2.d0
     
      return 
      end
***********************************************************************
      function sourwx(x)
       implicit none
      include 'commons.aniso'
      real *8 sourwx, x

      sourwx=((4.d0*(-1.d0 + (2.d0*x)/h))/h -
     1         (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function soursx(x)
       implicit none
      include 'commons.aniso'
      real *8 soursx, x

      soursx=((4.d0*(-1.d0 + (2.d0*x)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*x)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sourfy(y)
       implicit none
      include 'commons.aniso'
      real *8 sourfy, y
      
      sourfy= ((4.d0*(-1.d0 + (2.d0*y)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/4.d0
 
      return 
      end
***********************************************************************
      function sourey(y)
       implicit none
      include 'commons.aniso'
      real *8 sourey, y

      sourey= 1.d0/h + ((-4.d0*(-1.d0 + (2.d0*y)/h))/h + 
     1         (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/2.d0

      return 
      end
***********************************************************************
      function sourny(y)
       implicit none
      include 'commons.aniso'
      real *8 sourny, y

      sourny=((4.d0*(-1.d0 + (2.d0*y)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sourby(y)
       implicit none
      include 'commons.aniso'
      real *8 sourby, y

      sourby=((4.d0*(-1.d0 + (2.d0*y)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sourwy(y)
       implicit none
      include 'commons.aniso'
      real *8 sourwy, y

      sourwy=  -(1.d0/h) + ((-4.d0*(-1.d0 + (2.d0*y)/h))/h + 
     1           (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/2.d0

      return 
      end
***********************************************************************
      function soursy(y)
       implicit none
      include 'commons.aniso'
      real *8 soursy, y

      soursy=((4.d0*(-1.d0 + (2.d0*y)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*y)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sourfz(z)
       implicit none
      include 'commons.aniso'
      real *8 sourfz, z

      sourfz= ((4.d0*(-1.d0 + (2.d0*z)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/4.d0
     
      return 
      end
***********************************************************************
      function sourez(z)
       implicit none
      include 'commons.aniso'
      real *8 sourez, z

      sourez=((4.d0*(-1.d0 + (2.d0*z)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function sournz(z)
       implicit none
      include 'commons.aniso'
      real *8 sournz, z

      sournz= 1.d0/h + ((-4.d0*(-1.d0 + (2.d0*z)/h))/h + 
     1         (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/2.d0
 
      return 
      end
***********************************************************************
      function sourbz(z)
       implicit none
      include 'commons.aniso'
      real *8 sourbz, z

      sourbz=((4.d0*(-1.d0 + (2.d0*z)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/4.d0 
      
      return 
      end
***********************************************************************
      function sourwz(z)
       implicit none
      include 'commons.aniso'
      real *8 sourwz, z

      sourwz=((4.d0*(-1.d0 + (2.d0*z)/h))/h - 
     1         (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/4.d0

      return 
      end
***********************************************************************
      function soursz(z)
       implicit none
      include 'commons.aniso'
      real *8 soursz, z,relfac

      soursz=  -(1.d0/h) + ((-4.d0*(-1.d0 + (2.d0*z)/h))/h + 
     1           (40.d0*(-1.d0 + (2.d0*z)/h)**3)/(3.d0*h))/2.d0
      
      return 
      end
************************************************************************
      subroutine  materials
c
c  units  used: meters, grams, milliseconds (so frequency is measured in kHz)
       implicit none
       include 'commons.aniso'
       real*8 speed(mnmat)
       real*8 c11rmat(mnmat),c33rmat(mnmat),c44rmat(mnmat)
       real*8 c66rmat(mnmat),c13tir(mnmat),c13dsr(mnmat)
       real*8 c22rmat(mnmat),c55rmat(mnmat),c13rmat(mnmat)
       real*8 c12rmat(mnmat)
       integer i

c       sets number of materials

170    format(i5)
160    format(e20.8)
       read(5,170) nmat
       if(nmat.gt.mnmat) stop 222

c   sets density  [Kg/m^3]
       read(5,160) (rhomat(i),i=1,nmat)
c    sets  xmemat y xmumat, constant elastic bulk modulus of rock
c     [ newton/m^2 = Pascal ]
       read(5,160) (xmemat(i),i=1,nmat)
       read(5,160) (xmumat(i),i=1,nmat)
c    calc.  xmemat() = constant elastic of rock
      
c   Paso las unidades a gr, m y mseg y calculo lamda (xlam):
       do i=1,nmat
          rhomat(i)=rhomat(i)*1000.d0
          xmemat(i)=xmemat(i)/1000.d0
          xmumat(i)=xmumat(i)/1000.d0
       enddo

       do i=1,nmat
        xlammat(i)= xmemat(i) - 2.d0*xmumat(i)/3.d0
       enddo
  
       do i=1,nmat
        speed(i)=dsqrt( (xlammat(i)+2.d0*xmumat(i))/rhomat(i) )
       enddo
       vmax=speed(1)
       vmin=speed(1)
       do i=2,nmat
       if(speed(i).gt.vmax) vmax=speed(i)
       if(speed(i).lt.vmin) vmin=speed(i)
       enddo

      do i=1,nmat
       if(blockid.eq.ncontrol) then
       write(6,1099) i,speed(i)
       endif
1099   format(/1x,i5,' wave speed P(lam) = ',g15.5,' m/msec ')
      enddo
      do i=1,nmat
       speed(i)= dsqrt( xmumat(i)/rhomat(i) )
      enddo
       vmaxs=speed(1)
       vmins=speed(1)
       do i=2,nmat
       if(speed(i).gt.vmaxs) vmaxs=speed(i)
       if(speed(i).lt.vmins) vmins=speed(i)
       enddo

      do i=1,nmat
       if(blockid.eq.ncontrol) then
       write(6,1010) i,speed(i)
       endif
1010   format(/1x,i5,' wave speed S  = ',g15.5,' m/msec ')
      enddo
c  f. of T.I.
      read(5,160)(epsilon(i),i=1,nmat)
      read(5,160)(deltastar(i),i=1,nmat)
      read(5,160)(deltaTI(i),i=1,nmat)
      read(5,160)(gamma(i),i=1,nmat)
      read(5,170) isokey
       if(blockid.eq.ncontrol) then
           write(6,*) ' EPSILON POR TIPO DE MATERIAL'
       do i=1,nmat
       write(6,160) epsilon(i)
       enddo
           write(6,*) ' DELTASTAR POR TIPO DE MATERIAL '
       do i=1,nmat
       write(6,160) deltastar(i)
       enddo
           write(6,*) ' DELTATI POR TIPO DE MATERIAL'
       do i=1,nmat
       write(6,160) deltaTI(i)
       enddo
           write(6,*) ' GAMMA POR TIPO DE MATERIAL'
       do i=1,nmat
       write(6,160) gamma(i)
       enddo
       write(6,10108) isokey
       endif
10108     format(/1x,'isokey==1 for isotropic case ;',
     $   /1x,' isokey.NE.1 for anisotropic case
     $      ;',i5,//)

      do i=1,nmat
        c33rmat(i)= xlammat(i)+2.d0*xmumat(i)
        c44rmat(i)= xmumat(i)
        c11rmat(i)= c33rmat(i)*(1.d0+2.d0*epsilon(i))
        c22rmat(i)= c11rmat(i)
        c55rmat(i)= c44rmat(i)        
        c66rmat(i)= c44rmat(i)*(1.d0+2.d0*gamma(i))
c We use deltastar
        c13dsr(i)=0.5d0*(deltastar(i)*2.d0*c33rmat(i)**2 +
     1           (c33rmat(i)-c44rmat(i))*
     1           (c11rmat(i)+c33rmat(i)-2.d0*c44rmat(i)))
        c13dsr(i)= dsqrt(c13dsr(i)) - c44rmat(i)
        c13rmat(i)= c13dsr(i)
c if we use deltaTI (without c11)
c        c13tir(i)= deltaTI(i)*2.d0*c33rmat(i) *
c     1           (c33rmat(i)-c44rmat(i)) +
c     1           (c33rmat(i)-c44rmat(i))**2
c        c13tir(i)= dsqrt(c13tir(i)) - c44rmat(i)
c  
         c12rmat(i)= c11rmat(i)-2.d0*c66rmat(i)
c isotropic case
c
         if(isokey.eq.1) then
          c11rmat(i)= c33rmat(i)
          c66rmat(i)= c44rmat(i)
          c13dsr(i)= c33rmat(i) - 2.d0*c44rmat(i)
          c13tir(i)= c33rmat(i) - 2.d0*c44rmat(i)
         endif
c       if(blockid.eq.ncontrol) then
c         write(6,*) 'MODULOS ELASTICOS POR TIPO DE MATERIAL'	
c         write(6,*) 'c11mat - c22mat - c33mat '
c         write(6,123) c11mat(i),c22mat(i),c33mat(i)
c         write(6,*) 'c44mat - c55mat - c66mat)'
c         write(6,123) c44mat(i),c55mat(i),c66mat(i)
c         write(6,*) 'c12mat = c11mat-2*c66mat'
c         write(6,123) c11mat(i)-2.d0*c66mat(i)
c         write(6,*) 'c13mat ---> use deltastar (with c11)'
c         write(6,123) c13mat(i)
c         write(6,*) 'r = c13mat'
c         write(6,123) c13mat(i)
c       endif
       enddo
123     format(2g20.8)
c
c      sets  logaritmic decrement deltpmat = pi/Qm 
c
      read(5,160) (deltpmat(i),i=1,nmat)
      read(5,160) (deltsmat(i),i=1,nmat)
c
c    frequencies in Hz where  Q ~ Qm (equal for all materials)
c
         do i=1,nmat
      read(5,160) fq1mat(i)
      read(5,160) fq2mat(i)
         enddo

          return
           end        
******************************************************************
        subroutine coef
       implicit none
        include 'commons.aniso'	
        integer i		
        real*8 deltp,fq1,fq2,clp,tau1,tau2
        real*8 aux_1,aux_2,aux_3,aux_4,apm,bpm           
        real*8 xmu,cls,delts,asm,bsm,xmr
        real*8 c13r,c13i
        complex*16 xmuw,xlanw
        complex*16 xmw,c13
    
c    Ver como se elige anisotropia transversal!!
c    Las fq1mat son las que pasan en el commons (desde materials)

c    Liu model with continuous spectrum  of relaxation times
c    (includes elastic case for log. decr. deltp = 0)
c
c   Las unidades son gramos, metros y mseg (o KHz)

       do i=1,nmat

       deltp=deltpmat(i)
       delts=deltsmat(i)
c   Saco la atenuacion para ver si da todo igual que materials
c   Los cij y las vel cp y cs dan bien. Con c13 hay problemas????
c       deltp=0.d0
c       delts=0.d0
       xmu = xmumat(i)
       xmr=xmemat(i)+4.d0*xmumat(i)/3.d0
       fq1 = fq1mat(i)
       fq2 = fq2mat(i)

c	 xme=k, xmu=mu, xmr=M
c      deltp y delts= decrecim. logaritmicos
c	 fq1 y fq2= frec limites de Q=cte
c
c Constante 'C' y parametros tau1 y tau2 del modelo de Liu continuo

       clp=2.d0*deltp/(pi**2)
       cls=2.d0*delts/(pi**2)
       tau1=1.d0/(twopi*fq1)
       tau2=1.d0/(twopi*fq2)

       aux_1=1.d0+(omega*tau1)**2
       aux_2=1.d0+(omega*tau2)**2
       aux_3=omega*(tau1-tau2)
       aux_4=1.d0+ (omega*tau1)*(omega*tau2)

       apm=1.d0-.5d0*clp*dlog(aux_1/aux_2)
       bpm=clp*datan(aux_3/aux_4)

       asm=1.d0-.5d0*cls*dlog(aux_1/aux_2)
       bsm=cls*datan(aux_3/aux_4)

       xmw=dcmplx(xmr*apm,xmr*bpm)/(apm**2+bpm**2)
       xmuw=dcmplx(xmu*asm,xmu*bsm)/(asm**2+bsm**2)
       xlanw=xmw - 2.d0*xmuw
  
         if(blockid.eq.ncontrol) then
        write(6,1553) omega,i,dreal(xmw),dimag(xmw)
        write(6,1554) omega,i,dreal(xlanw),dimag(xlanw)
        write(6,1555) omega,i,dreal(xmuw),dimag(xmuw) 
1553     format(1x,'omega,i',/,'dreal(M),dimag(M)',g12.5,
     1            3x,i5,3x,2g15.5) 
1554     format(1x,'omega,i',/,'dreal(lambda),dimag(lambda)',g12.5,
     1            3x,i5,3x,2g15.5)
1555     format(1x,'omega,i',/,'dreal(mu),dimag(mu)',g12.5,
     1            3x,i5,3x,2g15.5) 
          endif 
c 
c    Aca calcule los mu, M y K complejos
c
c  coeff. of T.I.
        c33wmat(i) = xlanw+2.d0*xmuw
        c44wmat(i) = xmuw
        c11wmat(i) = c33wmat(i)*(1.d0+2.d0*epsilon(i))
        c66wmat(i) = c44wmat(i)*(1.d0+2.d0*gamma(i))
c We use deltastar
c        c13r=dreal(.5d0*(deltastar(i)*2.d0*c33mat(i)**2 +
c     1           (c33mat(i)-c44mat(i))*
c     1           (c11mat(i)+c33mat(i)-2.d0*c44mat(i))))
c        c13i=dimag(.5d0*(deltastar(i)*2.d0*c33mat(i)**2 +
c     1           (c33mat(i)-c44mat(i))*
c     1           (c11mat(i)+c33mat(i)-2.d0*c44mat(i))))
c        c13dsmat(i) = cdsqrt(dcmplx(c13r,c13i)) - c44mat(i)
        c13=.5d0*(deltastar(i)*2.d0*c33wmat(i)**2 +
     1           (c33wmat(i)-c44wmat(i))*
     1           (c11wmat(i)+c33wmat(i)-2.d0*c44wmat(i)))
        c13dsmat(i) = cdsqrt(c13) - c44wmat(i)
c if we use deltaTI (without c11)
c        c13r=dreal(deltaTI(i)*2.d0*c33mat(i) *
c     1           (c33mat(i)-c44mat(i)) +
c     1           (c33mat(i)-c44mat(i))**2)
c        c13i=dimag(deltaTI(i)*2.d0*c33mat(i) *
c     1           (c33mat(i)-c44mat(i)) +
c     1           (c33mat(i)-c44mat(i))**2)
c       c13timat(i) = cdsqrt(dcmplx(c13r,c13i)) - c44mat(i)
c
c elegir una de ambas opciones
c
       c13wmat(i) =  c13dsmat(i)
c       c13mat(i) =  c13timat(i)
c 
       c12wmat(i) = c11wmat(i)-2.d0*c66wmat(i)
c
        c14wmat(i) = dcmplx(0.d0,0.d0)
        c15wmat(i) = dcmplx(0.d0,0.d0)
        c16wmat(i) = dcmplx(0.d0,0.d0)
        c22wmat(i) = c11wmat(i)
        c23wmat(i) =  c13wmat(i)
        c24wmat(i) = dcmplx(0.d0,0.d0)
        c25wmat(i) = dcmplx(0.d0,0.d0)
        c26wmat(i) = dcmplx(0.d0,0.d0)
        c34wmat(i) = dcmplx(0.d0,0.d0)
        c35wmat(i) = dcmplx(0.d0,0.d0)
        c36wmat(i) = dcmplx(0.d0,0.d0)
        c45wmat(i) = dcmplx(0.d0,0.d0)
        c46wmat(i) = dcmplx(0.d0,0.d0)
        c55wmat(i) = c44wmat(i)
        c56wmat(i) = dcmplx(0.d0,0.d0)
c isotropic case
         if(isokey.eq.1) then
          c11wmat(i) = c33wmat(i)
          c22wmat(i) = c33wmat(i)
          c66wmat(i) = c44wmat(i)
          c55wmat(i) = c44wmat(i)
          c13wmat(i) = c33wmat(i) - 2.d0*c44wmat(i)
          c12wmat(i) = c13wmat(i) 
         endif
       if(blockid.eq.ncontrol) then	
         write(6,*) 'MODULOS COMPLEJOS POR TIPO DE MATERIAL'
         write(6,*) 'c11mat - c22mat - c33mat '
         write(6,123) c11wmat(i),c22wmat(i),c33wmat(i)
         write(6,*) 'c44mat - c55mat - c66mat)'
         write(6,123) c44wmat(i),c55wmat(i),c66wmat(i)
         write(6,*) 'c12mat = c11mat-2*c66mat'
         write(6,123) c11wmat(i)-2.d0*c66wmat(i)
         write(6,*) 'c13mat ---> use deltastar (with c11)'
         write(6,123) c13wmat(i)
         write(6,*) 'c23mat = c13mat'
         write(6,123) c13wmat(i)
c         write(6,*) 'c13mat ---> use delta (without c11)'
c        write(6,123) c13timat(i)
       endif
123     format(2g20.8)

        enddo

         return
	end	  
**************************************************************************
       subroutine setdelta
       implicit none
csp2--------------------------------------------------------------------
        include 'commons.aniso'
         integer x,y,z

           do  y=1,ny
             deltaw(y)=0.d0
             deltae(y)=0.d0
           enddo

           do   z=1,nz
             deltas(z)=0.d0
             deltan(z)=0.d0
           enddo
	   
           do   x=1,nx
             deltab(x)=0.d0
             deltaf(x)=0.d0
           enddo
c
c    independently of the block type, since we have full loops in the
c    x-variable we set the  deltas for the  back and front bries


             deltab(1)  = 1.0d0
	     deltaf(nx) = 1.0d0
	     	   
	   

      if(blockty.eq.0) then
                 deltaw(1) =1.d0
                 deltae(ny) =0.d0
                 deltas(1) =0.d0
                 deltan(nz) =1.d0
      elseif(blockty.eq.1) then
                 deltaw(1) =0.d0
                 deltae(ny) =0.d0
                 deltas(1) =0.d0
                 deltan(nz) =1.d0
      elseif(blockty.eq.2) then
                 deltaw(1) =0.d0
                 deltae(ny) =1.d0
                 deltas(1) =0.d0
                 deltan(nz) =1.d0
      elseif(blockty.eq.3) then
                 deltaw(1) =1.d0
                 deltae(ny) =0.d0
                 deltas(1) =0.d0
                 deltan(nz) =0.d0
      elseif(blockty.eq.4) then
                 deltaw(1) =0.d0
                 deltae(ny) =0.d0
                 deltas(1) =0.d0
                 deltan(nz) =0.d0
      elseif(blockty.eq.5) then
                 deltaw(1) =0.d0
                 deltae(ny) =1.d0
                 deltas(1) =0.d0
                 deltan(nz) =0.d0
      elseif(blockty.eq.6) then
                 deltaw(1) =1.d0
                 deltae(ny) =0.d0
                 deltas(1) =1.d0
                 deltan(nz) =0.d0
      elseif(blockty.eq.7) then
                 deltaw(1) =0.d0
                 deltae(ny) =0.d0
                 deltas(1) =1.d0
                 deltan(nz) =0.d0
      else
                 deltaw(1) =0.d0
                 deltae(ny) =1.d0
                 deltas(1) =1.d0
                 deltan(nz) =0.d0

      endif

      if(blockty.eq.9) then
                 deltaw(1) =1.d0
                 deltae(ny) =1.d0
                 deltas(1) =1.d0
                 deltan(nz) =1.d0
      endif

        return
        end
**********************************************************************
       subroutine subtype
       implicit none
       include 'commons.aniso'

       if(vblockid(1).eq.0.and.vblockid(2).eq.0)then
               blockty=0

        elseif(vblockid(1).eq.nsy-1.and.vblockid(2).eq.0)then
               blockty=2

        elseif(vblockid(1).eq.nsy-1.and.vblockid(2).eq.nsz-1)then
               blockty=8

        elseif(vblockid(1).eq.0.and.vblockid(2).eq.nsz-1)then
               blockty=6

        elseif(vblockid(2).eq.0)then
               blockty=1

        elseif(vblockid(1).eq.nsy-1)then
               blockty=5

        elseif(vblockid(2).eq.nsz-1)then
               blockty=7

        elseif(vblockid(1).eq.0)then
               blockty=3

        else
                blockty= 4
        endif

c       TMP - PARALLEL CODE
c     for running a serial code unccoment line below
c         blockty= 9

            return
                end
**************************************************************************
      subroutine inguess
       implicit none    
      include 'commons.aniso' 
      integer x,y,z,n
 
      do  x=0,nx+1
       do  y=0,ny+1
        do  z=0,nz+1
  
          lag1e(x,y,z)=dcmplx(0.d0,0.d0)
          lag1n(x,y,z)=dcmplx(0.d0,0.d0)
          lag1w(x,y,z)=dcmplx(0.d0,0.d0)
          lag1s(x,y,z)=dcmplx(0.d0,0.d0)
	 
          lag2e(x,y,z)=dcmplx(0.d0,0.d0)
          lag2n(x,y,z)=dcmplx(0.d0,0.d0)
          lag2w(x,y,z)=dcmplx(0.d0,0.d0)
          lag2s(x,y,z)=dcmplx(0.d0,0.d0)
	  
          lag3e(x,y,z)=dcmplx(0.d0,0.d0)
          lag3n(x,y,z)=dcmplx(0.d0,0.d0)
          lag3w(x,y,z)=dcmplx(0.d0,0.d0)
          lag3s(x,y,z)=dcmplx(0.d0,0.d0)
	  
          lagold1e(x,y,z)=dcmplx(0.d0,0.d0)
          lagold1n(x,y,z)=dcmplx(0.d0,0.d0)
          lagold1w(x,y,z)=dcmplx(0.d0,0.d0)
          lagold1s(x,y,z)=dcmplx(0.d0,0.d0)
       
          lagold2e(x,y,z)=dcmplx(0.d0,0.d0)
          lagold2n(x,y,z)=dcmplx(0.d0,0.d0)
          lagold2w(x,y,z)=dcmplx(0.d0,0.d0)
          lagold2s(x,y,z)=dcmplx(0.d0,0.d0)
       
          lagold3e(x,y,z)=dcmplx(0.d0,0.d0)
          lagold3n(x,y,z)=dcmplx(0.d0,0.d0)
          lagold3w(x,y,z)=dcmplx(0.d0,0.d0)
          lagold3s(x,y,z)=dcmplx(0.d0,0.d0)
       
          u1f(x,y,z)=dcmplx(0.d0,0.d0)
	  u1e(x,y,z)=dcmplx(0.d0,0.d0)
          u1n(x,y,z)=dcmplx(0.d0,0.d0)  
          u1b(x,y,z)=dcmplx(0.d0,0.d0)
	  u1w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  u1s(x,y,z)=dcmplx(0.d0,0.d0)
 
          u2f(x,y,z)=dcmplx(0.d0,0.d0)
	  u2e(x,y,z)=dcmplx(0.d0,0.d0)
          u2n(x,y,z)=dcmplx(0.d0,0.d0)  
          u2b(x,y,z)=dcmplx(0.d0,0.d0)
	  u2w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  u2s(x,y,z)=dcmplx(0.d0,0.d0)

          u3f(x,y,z)=dcmplx(0.d0,0.d0)
	  u3e(x,y,z)=dcmplx(0.d0,0.d0)
          u3n(x,y,z)=dcmplx(0.d0,0.d0)  
          u3b(x,y,z)=dcmplx(0.d0,0.d0)
	  u3w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  u3s(x,y,z)=dcmplx(0.d0,0.d0)	  

          uold1f(x,y,z)=dcmplx(0.d0,0.d0)
	  uold1e(x,y,z)=dcmplx(0.d0,0.d0)
          uold1n(x,y,z)=dcmplx(0.d0,0.d0)	  
          uold1b(x,y,z)=dcmplx(0.d0,0.d0)
	  uold1w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  uold1s(x,y,z)=dcmplx(0.d0,0.d0)	  
	  	 	   
          uold2f(x,y,z)=dcmplx(0.d0,0.d0)
	  uold2e(x,y,z)=dcmplx(0.d0,0.d0)
          uold2n(x,y,z)=dcmplx(0.d0,0.d0)	  
          uold2b(x,y,z)=dcmplx(0.d0,0.d0)
	  uold2w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  uold2s(x,y,z)=dcmplx(0.d0,0.d0)

	  uold3f(x,y,z)=dcmplx(0.d0,0.d0)
	  uold3e(x,y,z)=dcmplx(0.d0,0.d0)
          uold3n(x,y,z)=dcmplx(0.d0,0.d0) 
          uold3b(x,y,z)=dcmplx(0.d0,0.d0)
	  uold3w(x,y,z)=dcmplx(0.d0,0.d0)	 
	  uold3s(x,y,z)=dcmplx(0.d0,0.d0)	

         enddo
	enddo
       enddo
c
              do n=1,ntsnap
               do z=1,nz
                do y=1,ny
            tpic1yz(y,z,n) = 0.d0
            tpic2yz(y,z,n) = 0.d0
            tpic3yz(y,z,n) = 0.d0
                enddo
               enddo 
c
               do z=1,nz
                do x=1,nx
            tpic1xz(x,z,n) = 0.d0
            tpic2xz(x,z,n) = 0.d0
            tpic3xz(x,z,n) = 0.d0
                enddo
               enddo 
c
               do x=1,nx
                do y=1,ny
            tpic1xy(x,y,n) = 0.d0
            tpic2xy(x,y,n) = 0.d0
            tpic3xy(x,y,n) = 0.d0
                enddo 
               enddo
c
              enddo 
c
              do n=1,ntsnap
               do z=1,nz
                do y=1,ny
                 do x=1,nx
            tpic1(x,y,z,n) = 0.d0
            tpic2(x,y,z,n) = 0.d0
            tpic3(x,y,z,n) = 0.d0
                 enddo
                enddo
               enddo 
              enddo 
c
      return
      end        
**********************************************************************
      subroutine relerror_b(numb,denb)
       implicit none
      include 'commons.aniso'
      real*8 numb,denb
      integer x,y,z,ik

      numb=0.d0
      denb=0.d0
       do   z=1,nz
           if(mod(z,2).ne.0) ik=1
           if(mod(z,2).eq.0) ik=2
        do   y=ik,ny,2
            do x=1,nx
          numb=numb+( cdabs ( u1f(x,y,z) - uold1f(x,y,z)  ) )**2  
     1           +( cdabs ( u1e(x,y,z) - uold1e(x,y,z)  ) )**2 
     1           +( cdabs ( u1n(x,y,z) - uold1n(x,y,z)  ) )**2          
     1           +( cdabs ( u1b(x,y,z) - uold1b(x,y,z)  ) )**2      
     1           +( cdabs ( u1w(x,y,z) - uold1w(x,y,z)  ) )**2      
     1           +( cdabs ( u1s(x,y,z) - uold1s(x,y,z)  ) )**2    
     1           +( cdabs ( u2f(x,y,z) - uold2f(x,y,z)  ) )**2  
     1           +( cdabs ( u2e(x,y,z) - uold2e(x,y,z)  ) )**2 
     1           +( cdabs ( u2n(x,y,z) - uold2n(x,y,z)  ) )**2          
     1           +( cdabs ( u2b(x,y,z) - uold2b(x,y,z)  ) )**2      
     1           +( cdabs ( u2w(x,y,z) - uold2w(x,y,z)  ) )**2      
     1           +( cdabs ( u2s(x,y,z) - uold2s(x,y,z)  ) )**2   
     1           +( cdabs ( u3f(x,y,z) - uold3f(x,y,z)  ) )**2  
     1           +( cdabs ( u3e(x,y,z) - uold3e(x,y,z)  ) )**2 
     1           +( cdabs ( u3n(x,y,z) - uold3n(x,y,z)  ) )**2          
     1           +( cdabs ( u3b(x,y,z) - uold3b(x,y,z)  ) )**2      
     1           +( cdabs ( u3w(x,y,z) - uold3w(x,y,z)  ) )**2      
     1           +( cdabs ( u3s(x,y,z) - uold3s(x,y,z)  ) )**2     
      	  
          denb=denb+( cdabs ( u1f(x,y,z) + uold1f(x,y,z)  ) )**2  
     1           +( cdabs ( u1e(x,y,z) + uold1e(x,y,z)  ) )**2 
     1           +( cdabs ( u1n(x,y,z) + uold1n(x,y,z)  ) )**2            
     1           +( cdabs ( u1b(x,y,z) + uold1b(x,y,z)  ) )**2      
     1           +( cdabs ( u1w(x,y,z) + uold1w(x,y,z)  ) )**2      
     1           +( cdabs ( u1s(x,y,z) + uold1s(x,y,z)  ) )**2  	  
     1           +( cdabs ( u2f(x,y,z) + uold2f(x,y,z)  ) )**2  
     1           +( cdabs ( u2e(x,y,z) + uold2e(x,y,z)  ) )**2 
     1           +( cdabs ( u2n(x,y,z) + uold2n(x,y,z)  ) )**2            
     1           +( cdabs ( u2b(x,y,z) + uold2b(x,y,z)  ) )**2      
     1           +( cdabs ( u2w(x,y,z) + uold2w(x,y,z)  ) )**2      
     1           +( cdabs ( u2s(x,y,z) + uold2s(x,y,z)  ) )**2  	  
     1           +( cdabs ( u3f(x,y,z) + uold3f(x,y,z)  ) )**2  
     1           +( cdabs ( u3e(x,y,z) + uold3e(x,y,z)  ) )**2 
     1           +( cdabs ( u3n(x,y,z) + uold3n(x,y,z)  ) )**2            
     1           +( cdabs ( u3b(x,y,z) + uold3b(x,y,z)  ) )**2      
     1           +( cdabs ( u3w(x,y,z) + uold3w(x,y,z)  ) )**2      
     1           +( cdabs ( u3s(x,y,z) + uold3s(x,y,z)  ) )**2  	       
         enddo
	enddo
       enddo

      return
      end
**********************************************************************
      subroutine relerror_r(numr,denr)
       implicit none
      include 'commons.aniso'
      real*8 numr,denr
      integer x,y,z,ik

      numr=0.d0
      denr=0.d0

       do   z=1,nz
           if(mod(z,2).ne.0) ik=2
           if(mod(z,2).eq.0) ik=1
        do   y=ik,ny,2
            do x=1,nx
          numr=numr+( cdabs ( u1f(x,y,z) - uold1f(x,y,z)  ) )**2  
     1           +( cdabs ( u1e(x,y,z) - uold1e(x,y,z)  ) )**2 
     1           +( cdabs ( u1n(x,y,z) - uold1n(x,y,z)  ) )**2          
     1           +( cdabs ( u1b(x,y,z) - uold1b(x,y,z)  ) )**2      
     1           +( cdabs ( u1w(x,y,z) - uold1w(x,y,z)  ) )**2      
     1           +( cdabs ( u1s(x,y,z) - uold1s(x,y,z)  ) )**2    
     1           +( cdabs ( u2f(x,y,z) - uold2f(x,y,z)  ) )**2  
     1           +( cdabs ( u2e(x,y,z) - uold2e(x,y,z)  ) )**2 
     1           +( cdabs ( u2n(x,y,z) - uold2n(x,y,z)  ) )**2          
     1           +( cdabs ( u2b(x,y,z) - uold2b(x,y,z)  ) )**2      
     1           +( cdabs ( u2w(x,y,z) - uold2w(x,y,z)  ) )**2      
     1           +( cdabs ( u2s(x,y,z) - uold2s(x,y,z)  ) )**2   
     1           +( cdabs ( u3f(x,y,z) - uold3f(x,y,z)  ) )**2  
     1           +( cdabs ( u3e(x,y,z) - uold3e(x,y,z)  ) )**2 
     1           +( cdabs ( u3n(x,y,z) - uold3n(x,y,z)  ) )**2          
     1           +( cdabs ( u3b(x,y,z) - uold3b(x,y,z)  ) )**2      
     1           +( cdabs ( u3w(x,y,z) - uold3w(x,y,z)  ) )**2      
     1           +( cdabs ( u3s(x,y,z) - uold3s(x,y,z)  ) )**2     
      	  
          denr=denr+( cdabs ( u1f(x,y,z) + uold1f(x,y,z)  ) )**2  
     1           +( cdabs ( u1e(x,y,z) + uold1e(x,y,z)  ) )**2 
     1           +( cdabs ( u1n(x,y,z) + uold1n(x,y,z)  ) )**2            
     1           +( cdabs ( u1b(x,y,z) + uold1b(x,y,z)  ) )**2      
     1           +( cdabs ( u1w(x,y,z) + uold1w(x,y,z)  ) )**2      
     1           +( cdabs ( u1s(x,y,z) + uold1s(x,y,z)  ) )**2  	  
     1           +( cdabs ( u2f(x,y,z) + uold2f(x,y,z)  ) )**2  
     1           +( cdabs ( u2e(x,y,z) + uold2e(x,y,z)  ) )**2 
     1           +( cdabs ( u2n(x,y,z) + uold2n(x,y,z)  ) )**2            
     1           +( cdabs ( u2b(x,y,z) + uold2b(x,y,z)  ) )**2      
     1           +( cdabs ( u2w(x,y,z) + uold2w(x,y,z)  ) )**2      
     1           +( cdabs ( u2s(x,y,z) + uold2s(x,y,z)  ) )**2  	  
     1           +( cdabs ( u3f(x,y,z) + uold3f(x,y,z)  ) )**2  
     1           +( cdabs ( u3e(x,y,z) + uold3e(x,y,z)  ) )**2 
     1           +( cdabs ( u3n(x,y,z) + uold3n(x,y,z)  ) )**2            
     1           +( cdabs ( u3b(x,y,z) + uold3b(x,y,z)  ) )**2      
     1           +( cdabs ( u3w(x,y,z) + uold3w(x,y,z)  ) )**2      
     1           +( cdabs ( u3s(x,y,z) + uold3s(x,y,z)  ) )**2  
         enddo
	enddo
       enddo

      return
      end
***********************************************************************
       subroutine uplagb
       implicit none
       include 'commons.aniso'
        integer kk,ll,ik    

       do ll=1,nz
           if(mod(ll,2).ne.0) ik=1
           if(mod(ll,2).eq.0) ik=2
         do kk=ik,ny,2
             call uplag(ll,kk)
         enddo
       enddo
          return
	  end	 
***********************************************************************
       subroutine uplagr
       implicit none
       include 'commons.aniso'
        integer kk,ll,ik

       do ll=1,nz
           if(mod(ll,2).ne.0) ik=2
           if(mod(ll,2).eq.0) ik=1
         do kk=ik,ny,2
             call uplag(ll,kk)
         enddo
       enddo	  
          return
	  end
***********************************************************************
      subroutine uplag(ll,kk)
      implicit none
      include 'commons.aniso'
      integer  x,y,z,i,ik,il,ll,kk
      complex *16 aim
      real*8 avvp,avvs1,avvs2
      real*8 avrho,facbeta
      real*8 rhojm1,rhojp1,rhokm1,rhokp1,rholm1,rholp1
      complex*16 c11,c12,c13,c14,c15,c16
      complex*16 c22,c23,c24,c25,c26
      complex*16 c33,c34,c35,c36
      complex*16 c44,c45,c46,c55,c56,c66
      complex*16 c11jm1,c11jp1,c11km1,c11kp1,c66km1,c66kp1,c66jm1
      complex*16 c66jp1,c44lm1,c44lp1,c44jm1,c44jp1,c44km1,c44kp1
      complex*16 c22km1,c22kp1,c55lm1,c55lp1
      complex*16 c33lm1,c33lp1
      real*8 posz,auxz,posy,auxy
      
      aim = dcmplx(0.d0,1.d0)
      facbeta = 1.d0
      y=kk
      z=ll      
c
c  computes Global position  coordinate in the  y-direction
c
            posy = vblockid(1)*hpy + (y-1)*h +.5d0*h
	    auxy = posy/h +1.d0
	    ik =int(auxy)
c
c  computes Global position  coordinate in the  z-direction
c
            posz = ((nsz-1)-vblockid(2))*hpz+ (z-1)*h + 0.5d0*h
            auxz = posz/h +1.d0
            il =int(auxz)
c
      do x=1,nx

       i = matnum(x,ik,il)
       c11=c11mat(i,jw)
       c12=c12mat(i,jw)
       c13=c13mat(i,jw)
       c14=c14mat(i,jw)
       c15=c15mat(i,jw)  
       c16=c16mat(i,jw)
       c22=c22mat(i,jw)
       c23=c23mat(i,jw)
       c24=c24mat(i,jw)
       c25=c25mat(i,jw)
       c26=c26mat(i,jw)
       c33=c33mat(i,jw)
       c34=c34mat(i,jw)
       c35=c35mat(i,jw)
       c36=c36mat(i,jw)   
       c44=c44mat(i,jw)
       c45=c45mat(i,jw)
       c46=c46mat(i,jw)
       c55=c55mat(i,jw)
       c56=c56mat(i,jw)
       c66=c66mat(i,jw)
       rho=rhomat(i) 

c       i = matnum(x-1,ik,il)
c       c11jm1=c11mat(i)
c       c55jm1=c55mat(i)
c       c66jm1=c66mat(i)
c       rhojm1=rhomat(i)

c       i = matnum(x+1,ik,il)
c       c11jp1=c11mat(i)
c       c55jp1=c55mat(i)
c       c66jp1=c66mat(i)
c       rhojp1=rhomat(i)
   
       i = matnum(x,ik-1,il)
       c22km1=c22mat(i,jw)
       c44km1=c44mat(i,jw)
       c66km1=c66mat(i,jw)
       rhokm1=rhomat(i)

       i = matnum(x,ik+1,il)
       c22kp1=c22mat(i,jw)
       c44kp1=c44mat(i,jw)
       c66kp1=c66mat(i,jw)
       rhokp1=rhomat(i)

       i = matnum(x,ik,il-1)
       c33lm1=c33mat(i,jw)
       c44lm1=c44mat(i,jw)
       c55lm1=c55mat(i,jw)
       rholm1=rhomat(i)
      
       i = matnum(x,ik,il+1)
       c33lp1=c33mat(i,jw)
       c44lp1=c44mat(i,jw)
       c55lp1=c55mat(i,jw)
       rholp1=rhomat(i)
	 
c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta1b =  avrho*avvp*facbeta*omega	

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta2b =  avrho*avvs1*facbeta*omega

c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jm1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojm1))
c         beta3b =  avrho*avvs2*facbeta*omega	

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta1e =  avrho*avvs1*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta2e =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44kp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokp1))
         beta3e =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta1w =  avrho*avvs1*facbeta*omega
 
         avvp = 0.5d0*(dsqrt(dreal(c22))+dsqrt(dreal(c22km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta2w =  avrho*avvp*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44km1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhokm1))
         beta3w =  avrho*avvs2*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta1n =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta2n =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lp1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholp1))
         beta3n =  avrho*avvp*facbeta*omega

         avvs1 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta1s =  avrho*avvs1*facbeta*omega

         avvs2 = 0.5d0*(dsqrt(dreal(c44))+dsqrt(dreal(c44lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta2s =  avrho*avvs2*facbeta*omega

         avvp = 0.5d0*(dsqrt(dreal(c33))+dsqrt(dreal(c33lm1)))
         avrho  = .5d0*(dsqrt(rho)+dsqrt(rholm1))
         beta3s =  avrho*avvp*facbeta*omega

c         avvp = 0.5d0*(dsqrt(dreal(c11))+dsqrt(dreal(c11jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta1f =  avrho*avvp*facbeta*omega

c         avvs1 = 0.5d0*(dsqrt(dreal(c66))+dsqrt(dreal(c66jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta2f =  avrho*avvs1*facbeta*omega
	 
c         avvs2 = 0.5d0*(dsqrt(dreal(c55))+dsqrt(dreal(c55jp1)))
c         avrho  = .5d0*(dsqrt(rho)+dsqrt(rhojp1))
c         beta3f =  avrho*avvs2*facbeta*omega
     
         lag1e(x,y,z)=-lag1w(x,y+1,z) +
     1               aim * beta1e*(u1e(x,y,z)-u1w(x,y+1,z))  
     
         lag1w(x,y,z)=-lag1e(x,y-1,z) +
     1               aim * beta1w*(u1w(x,y,z)-u1e(x,y-1,z))  
          
         lag1n(x,y,z)=-lag1s(x,y,z+1) +
     1               aim * beta1n*(u1n(x,y,z)-u1s(x,y,z+1)) 

         lag1s(x,y,z)=-lag1n(x,y,z-1) +
     1               aim * beta1s*(u1s(x,y,z)-u1n(x,y,z-1))
         
         lag2e(x,y,z)=-lag2w(x,y+1,z) +
     1               aim * beta2e*(u2e(x,y,z)-u2w(x,y+1,z))  
     
         lag2w(x,y,z)=-lag2e(x,y-1,z) +
     1               aim * beta2w*(u2w(x,y,z)-u2e(x,y-1,z))  
          
         lag2n(x,y,z)=-lag2s(x,y,z+1) +
     1               aim * beta2n*(u2n(x,y,z)-u2s(x,y,z+1)) 
     
         lag2s(x,y,z)=-lag2n(x,y,z-1) +
     1               aim * beta2s*(u2s(x,y,z)-u2n(x,y,z-1))
               
         lag3e(x,y,z)=-lag3w(x,y+1,z) +
     1               aim * beta3e*(u3e(x,y,z)-u3w(x,y+1,z))  
     
         lag3w(x,y,z)=-lag3e(x,y-1,z) +
     1               aim * beta3w*(u3w(x,y,z)-u3e(x,y-1,z))  
          
         lag3n(x,y,z)=-lag3s(x,y,z+1) +
     1               aim * beta3n*(u3n(x,y,z)-u3s(x,y,z+1)) 
     
         lag3s(x,y,z)=-lag3n(x,y,z-1) +
     1               aim * beta3s*(u3s(x,y,z)-u3n(x,y,z-1))
      enddo
          	  
      return
      end 
************************************************************************
      subroutine shift_b
       implicit none
      include 'commons.aniso'
      integer  x,y,z,ik

       do   z=1,nz
           if(mod(z,2).ne.0) ik=1
           if(mod(z,2).eq.0) ik=2
        do   y=ik,ny,2
            do x=1,nx
         uold1f(x,y,z)=u1f(x,y,z)
         uold1e(x,y,z)=u1e(x,y,z)
         uold1n(x,y,z)=u1n(x,y,z)  
  	 uold1b(x,y,z)=u1b(x,y,z)
         uold1w(x,y,z)=u1w(x,y,z)
         uold1s(x,y,z)=u1s(x,y,z)

         uold2f(x,y,z)=u2f(x,y,z)
         uold2e(x,y,z)=u2e(x,y,z)
         uold2n(x,y,z)=u2n(x,y,z)        
	 uold2b(x,y,z)=u2b(x,y,z)
         uold2w(x,y,z)=u2w(x,y,z)
         uold2s(x,y,z)=u2s(x,y,z)
   	
	 uold3f(x,y,z)=u3f(x,y,z)
         uold3e(x,y,z)=u3e(x,y,z)
         uold3n(x,y,z)=u3n(x,y,z)      
	 uold3b(x,y,z)=u3b(x,y,z)
         uold3w(x,y,z)=u3w(x,y,z)
         uold3s(x,y,z)=u3s(x,y,z)
	 
         lagold1e(x,y,z)=lag1e(x,y,z)
         lagold1n(x,y,z)=lag1n(x,y,z)
         lagold1w(x,y,z)=lag1w(x,y,z)
         lagold1s(x,y,z)=lag1s(x,y,z)

         lagold2e(x,y,z)=lag2e(x,y,z)
         lagold2n(x,y,z)=lag2n(x,y,z)
         lagold2w(x,y,z)=lag2w(x,y,z)
         lagold2s(x,y,z)=lag2s(x,y,z)

         lagold3e(x,y,z)=lag3e(x,y,z)
         lagold3n(x,y,z)=lag3n(x,y,z)
         lagold3w(x,y,z)=lag3w(x,y,z)
         lagold3s(x,y,z)=lag3s(x,y,z)
            enddo
	enddo
       enddo

      return
      end 	
************************************************************************
      subroutine shift_r
       implicit none
      include 'commons.aniso'
      integer  x,y,z,ik

       do   z=1,nz
           if(mod(z,2).ne.0) ik=2
           if(mod(z,2).eq.0) ik=1
        do   y=ik,ny,2
            do x=1,nx

         uold1f(x,y,z)=u1f(x,y,z)
         uold1e(x,y,z)=u1e(x,y,z)
         uold1n(x,y,z)=u1n(x,y,z)  
  	 uold1b(x,y,z)=u1b(x,y,z)
         uold1w(x,y,z)=u1w(x,y,z)
         uold1s(x,y,z)=u1s(x,y,z)

         uold2f(x,y,z)=u2f(x,y,z)
         uold2e(x,y,z)=u2e(x,y,z)
         uold2n(x,y,z)=u2n(x,y,z)        
	 uold2b(x,y,z)=u2b(x,y,z)
         uold2w(x,y,z)=u2w(x,y,z)
         uold2s(x,y,z)=u2s(x,y,z)
   	
	 uold3f(x,y,z)=u3f(x,y,z)
         uold3e(x,y,z)=u3e(x,y,z)
         uold3n(x,y,z)=u3n(x,y,z)      
	 uold3b(x,y,z)=u3b(x,y,z)
         uold3w(x,y,z)=u3w(x,y,z)
         uold3s(x,y,z)=u3s(x,y,z)

         lagold1e(x,y,z)=lag1e(x,y,z)
         lagold1n(x,y,z)=lag1n(x,y,z)
         lagold1w(x,y,z)=lag1w(x,y,z)
         lagold1s(x,y,z)=lag1s(x,y,z)

         lagold2e(x,y,z)=lag2e(x,y,z)
         lagold2n(x,y,z)=lag2n(x,y,z)
         lagold2w(x,y,z)=lag2w(x,y,z)
         lagold2s(x,y,z)=lag2s(x,y,z)

         lagold3e(x,y,z)=lag3e(x,y,z)
         lagold3n(x,y,z)=lag3n(x,y,z)
         lagold3w(x,y,z)=lag3w(x,y,z)
         lagold3s(x,y,z)=lag3s(x,y,z)
            enddo
	enddo
       enddo
	 
      return
      end 	
************************************************************************
      subroutine failoutput
       implicit none   
      include 'commons.aniso'

      if(blockid.eq.ncontrol) then      
      write(6,10)iter,error
      endif
   10 format(/' NO CONVERGENCE  after iteration #= ',i5,
     *       '(=imax),',3x,' relative error=',e12.5)
  
      return
      end 

************************************************************************
       subroutine output(iw)
       implicit none   
       include 'commons.aniso'
       integer x,y,z,iw
       complex*16 auxi1

c  2d pictures at the vertical section of domain
c	write(90+iw,*) 'Cortes 2D para yz en x=nx/2'   
c        write(90+iw,*) iw

c	x=nx/2
c   	do y=1,ny
c        do z=1,nz
c        auxi1=(u1f(x,y,z) +u1e(x,y,z) +u1n(x,y,z) +u1b(x,y,z) +
c     1   u1s(x,y,z) +u1w(x,y,z) )/6.
c	write(90+iw,*) dreal(auxi1) 
c        enddo
c	enddo
c
c	y=ny/2
c   	do x=1,nx
c        do z=1,nz
c        auxi1=(u1f(x,y,z) +u1e(x,y,z) +u1n(x,y,z) +u1b(x,y,z) +
c     1   u1s(x,y,z) +u1w(x,y,z) )/6.
c	write(94+iw,*) dreal(auxi1) 
c        enddo
c	enddo
c
c	z=nz/2
c   	do x=1,nx
c        do y=1,ny
c        auxi1=(u1f(x,y,z) +u1e(x,y,z) +u1n(x,y,z) +u1b(x,y,z) +
c     1   u1s(x,y,z) +u1w(x,y,z) )/6.
c	write(97+iw,*) dreal(auxi1) 
c        enddo
c	enddo
c
c    writes 1-D slice of uc on a line parallel to x axis
c     
c            x=nx/2
c	    z = nz/2
c	    do y=1,ny
c        auxi1=(u1f(x,y,z) +u1e(x,y,z) +u1n(x,y,z) +u1b(x,y,z) +
c     1   u1s(x,y,z) +u1w(x,y,z) )/6.d0
c             write(19+iw,12)(y-1)*h + h/2.d0,dreal(auxi1)
12           format(2e15.5)
c             enddo
c
c	    do y=1,ny
c             write(97+iw,12) y*h ,dreal(u1e(x,y,z))
c              enddo
	
c           do z=1,nz
c           do y=1,ny
             z=lsou
             y=ksou
           do x=1,nx

           write(1,*) 'x = ',x,'y = ',y,'z = ',z
           write(1,*) 'u1b(x,y,z) =',u1b(x,y,z)
           write(1,*) 'u2b(x,y,z) =',u2b(x,y,z)
           write(1,*) 'u3b(x,y,z) =',u3b(x,y,z)
           write(1,*) 'u1e(x,y,z) =',u1e(x,y,z)
           write(1,*) 'u2e(x,y,z) =',u2e(x,y,z)
           write(1,*) 'u3e(x,y,z) =',u3e(x,y,z)
           write(1,*) 'u1w(x,y,z) =',u1w(x,y,z)
           write(1,*) 'u2w(x,y,z) =',u2w(x,y,z)
           write(1,*) 'u3w(x,y,z) =',u3w(x,y,z)
           write(1,*) 'u1n(x,y,z) =',u1n(x,y,z)
           write(1,*) 'u2n(x,y,z) =',u2n(x,y,z)
           write(1,*) 'u3n(x,y,z) =',u3n(x,y,z)
           write(1,*) 'u1s(x,y,z) =',u1s(x,y,z)
           write(1,*) 'u2s(x,y,z) =',u2s(x,y,z)
           write(1,*) 'u3s(x,y,z) =',u3s(x,y,z)
           write(1,*) 'u1f(x,y,z) =',u1f(x,y,z)
           write(1,*) 'u2f(x,y,z) =',u2f(x,y,z)
           write(1,*) 'u3f(x,y,z) =',u3f(x,y,z)
           write(1,*)

           enddo
c           enddo
c           enddo

c           stop 11223
     
	return
        end
************************************************************************
      subroutine relaxb
       implicit none
      include 'commons.aniso'
      integer  x,y,z,ik
      double precision  relfac

       relfac = .9d0
       do z=1,nz
           if(mod(z,2).ne.0) ik=1
           if(mod(z,2).eq.0) ik=2
         do y=ik,ny,2
            do x=1,nx
        u1f(x,y,z) = (1.d0-relfac)*uold1f(x,y,z)+relfac*u1f(x,y,z)
        u1e(x,y,z) = (1.d0-relfac)*uold1e(x,y,z)+relfac*u1e(x,y,z)
        u1n(x,y,z) = (1.d0-relfac)*uold1n(x,y,z)+relfac*u1n(x,y,z)	       	
        u1b(x,y,z) = (1.d0-relfac)*uold1b(x,y,z)+relfac*u1b(x,y,z)	
        u1w(x,y,z) = (1.d0-relfac)*uold1w(x,y,z)+relfac*u1w(x,y,z)
        u1s(x,y,z) = (1.d0-relfac)*uold1s(x,y,z)+relfac*u1s(x,y,z)	
        u2f(x,y,z) = (1.d0-relfac)*uold2f(x,y,z)+relfac*u2f(x,y,z)
        u2e(x,y,z) = (1.d0-relfac)*uold2e(x,y,z)+relfac*u2e(x,y,z)	
        u2n(x,y,z) = (1.d0-relfac)*uold2n(x,y,z)+relfac*u2n(x,y,z)	
        u2b(x,y,z) = (1.d0-relfac)*uold2b(x,y,z)+relfac*u2b(x,y,z)	
        u2w(x,y,z) = (1.d0-relfac)*uold2w(x,y,z)+relfac*u2w(x,y,z)
        u2s(x,y,z) = (1.d0-relfac)*uold2s(x,y,z)+relfac*u2s(x,y,z)	
        u3f(x,y,z) = (1.d0-relfac)*uold3f(x,y,z)+relfac*u3f(x,y,z)
        u3e(x,y,z) = (1.d0-relfac)*uold3e(x,y,z)+relfac*u3e(x,y,z)	
        u3n(x,y,z) = (1.d0-relfac)*uold3n(x,y,z)+relfac*u3n(x,y,z)	
        u3b(x,y,z) = (1.d0-relfac)*uold3b(x,y,z)+relfac*u3b(x,y,z)	
        u3w(x,y,z) = (1.d0-relfac)*uold3w(x,y,z)+relfac*u3w(x,y,z)
        u3s(x,y,z) = (1.d0-relfac)*uold3s(x,y,z)+relfac*u3s(x,y,z)		
      lag1e(x,y,z) = (1.d0-relfac)*lagold1e(x,y,z)+relfac*lag1e(x,y,z)	
      lag1n(x,y,z) = (1.d0-relfac)*lagold1n(x,y,z)+relfac*lag1n(x,y,z)	
      lag1w(x,y,z) = (1.d0-relfac)*lagold1w(x,y,z)+relfac*lag1w(x,y,z)
      lag1s(x,y,z) = (1.d0-relfac)*lagold1s(x,y,z)+relfac*lag1s(x,y,z)	
      lag2e(x,y,z) = (1.d0-relfac)*lagold2e(x,y,z)+relfac*lag2e(x,y,z)	
      lag2n(x,y,z) = (1.d0-relfac)*lagold2n(x,y,z)+relfac*lag2n(x,y,z)	
      lag2w(x,y,z) = (1.d0-relfac)*lagold2w(x,y,z)+relfac*lag2w(x,y,z)
      lag2s(x,y,z) = (1.d0-relfac)*lagold2s(x,y,z)+relfac*lag2s(x,y,z)	
      lag3e(x,y,z) = (1.d0-relfac)*lagold3e(x,y,z)+relfac*lag3e(x,y,z)	
      lag3n(x,y,z) = (1.d0-relfac)*lagold3n(x,y,z)+relfac*lag3n(x,y,z)	
      lag3w(x,y,z) = (1.d0-relfac)*lagold3w(x,y,z)+relfac*lag3w(x,y,z)
      lag3s(x,y,z) = (1.d0-relfac)*lagold3s(x,y,z)+relfac*lag3s(x,y,z)
            enddo
	 enddo
       enddo
	
      return
      end 	
************************************************************************
      subroutine relaxr
       implicit none
      include 'commons.aniso'
      integer  x,y,z,ik
      double precision  relfac

       relfac = .9d0
       do z=1,nz
           if(mod(z,2).ne.0) ik=2
           if(mod(z,2).eq.0) ik=1
         do y=ik,ny,2
            do x=1,nx
        u1f(x,y,z) = (1.d0-relfac)*uold1f(x,y,z)+relfac*u1f(x,y,z)
        u1e(x,y,z) = (1.d0-relfac)*uold1e(x,y,z)+relfac*u1e(x,y,z)
        u1n(x,y,z) = (1.d0-relfac)*uold1n(x,y,z)+relfac*u1n(x,y,z)	       	
        u1b(x,y,z) = (1.d0-relfac)*uold1b(x,y,z)+relfac*u1b(x,y,z)	
        u1w(x,y,z) = (1.d0-relfac)*uold1w(x,y,z)+relfac*u1w(x,y,z)
        u1s(x,y,z) = (1.d0-relfac)*uold1s(x,y,z)+relfac*u1s(x,y,z)	
        u2f(x,y,z) = (1.d0-relfac)*uold2f(x,y,z)+relfac*u2f(x,y,z)
        u2e(x,y,z) = (1.d0-relfac)*uold2e(x,y,z)+relfac*u2e(x,y,z)	
        u2n(x,y,z) = (1.d0-relfac)*uold2n(x,y,z)+relfac*u2n(x,y,z)	
        u2b(x,y,z) = (1.d0-relfac)*uold2b(x,y,z)+relfac*u2b(x,y,z)	
        u2w(x,y,z) = (1.d0-relfac)*uold2w(x,y,z)+relfac*u2w(x,y,z)
        u2s(x,y,z) = (1.d0-relfac)*uold2s(x,y,z)+relfac*u2s(x,y,z)	
        u3f(x,y,z) = (1.d0-relfac)*uold3f(x,y,z)+relfac*u3f(x,y,z)
        u3e(x,y,z) = (1.d0-relfac)*uold3e(x,y,z)+relfac*u3e(x,y,z)	
        u3n(x,y,z) = (1.d0-relfac)*uold3n(x,y,z)+relfac*u3n(x,y,z)	
        u3b(x,y,z) = (1.d0-relfac)*uold3b(x,y,z)+relfac*u3b(x,y,z)	
        u3w(x,y,z) = (1.d0-relfac)*uold3w(x,y,z)+relfac*u3w(x,y,z)
        u3s(x,y,z) = (1.d0-relfac)*uold3s(x,y,z)+relfac*u3s(x,y,z)		
      lag1e(x,y,z) = (1.d0-relfac)*lagold1e(x,y,z)+relfac*lag1e(x,y,z)	
      lag1n(x,y,z) = (1.d0-relfac)*lagold1n(x,y,z)+relfac*lag1n(x,y,z)	
      lag1w(x,y,z) = (1.d0-relfac)*lagold1w(x,y,z)+relfac*lag1w(x,y,z)
      lag1s(x,y,z) = (1.d0-relfac)*lagold1s(x,y,z)+relfac*lag1s(x,y,z)	
      lag2e(x,y,z) = (1.d0-relfac)*lagold2e(x,y,z)+relfac*lag2e(x,y,z)	
      lag2n(x,y,z) = (1.d0-relfac)*lagold2n(x,y,z)+relfac*lag2n(x,y,z)	
      lag2w(x,y,z) = (1.d0-relfac)*lagold2w(x,y,z)+relfac*lag2w(x,y,z)
      lag2s(x,y,z) = (1.d0-relfac)*lagold2s(x,y,z)+relfac*lag2s(x,y,z)	
      lag3e(x,y,z) = (1.d0-relfac)*lagold3e(x,y,z)+relfac*lag3e(x,y,z)	
      lag3n(x,y,z) = (1.d0-relfac)*lagold3n(x,y,z)+relfac*lag3n(x,y,z)	
      lag3w(x,y,z) = (1.d0-relfac)*lagold3w(x,y,z)+relfac*lag3w(x,y,z)
      lag3s(x,y,z) = (1.d0-relfac)*lagold3s(x,y,z)+relfac*lag3s(x,y,z)
            enddo
	 enddo
       enddo
	
      return
      end 	
************************************************************************
      subroutine nodes
       implicit none
      include 'commons.aniso'
      integer jj,jx

      do jj=1,nx
         do jx=1,18
         ngnod(jj,jx)=15*(jj-1)+jx
         enddo
      enddo

      return
      end
**********************************************************************
      subroutine banda(k,l)
       implicit none
      include 'commons.aniso'
      integer ii,n,m1,jj,k11,kk,k,l
      parameter(n=nunk)
      complex*16 sum

      do ii=2,n
      m1=min0(ib-1,n-ii+1)
      do jj=1,m1
      sum=dcmplx(0.d0,0.d0)
      k11=min0(ii-1,ib-jj)
      do kk=1,k11
      sum=sum+a(ii-kk,kk+1,k,l)*a(ii-kk,jj+kk,k,l)/a(ii-kk,1,k,l)
      enddo
      a(ii,jj,k,l)=a(ii,jj,k,l)-sum
      enddo
      enddo
     
      return
      end
********************************************************
      subroutine rhsb(sol,k,l)
       implicit none
      include 'commons.aniso'
      integer n,np1,ii,k11,kk,j11,j22,jj,mm,k,l
      parameter(n=nunk)
      complex*16 sol(nunk),sum

      np1=n+1
      do ii=2,n
      sum=dcmplx(0.d0,0.d0)
      k11=min0(ib-1,ii-1)
      do kk=1,k11
      sum=sum+a(ii-kk,kk+1,k,l)*b(ii-kk)/a(ii-kk,1,k,l)
      enddo
      b(ii)=b(ii)-sum
      enddo
c
      sol(n)=b(n)/a(n,1,k,l)
      do kk=2,n
      ii=np1-kk
      j11=ii+1
      j22=min0(n,ii+ib-1)
      sum=dcmplx(0.d0,0.d0)
      do jj=j11,j22
      mm=jj-j11+2
      sum=sum+sol(jj)*a(ii,mm,k,l)
      enddo
      sol(ii)=(b(ii)-sum)/a(ii,1,k,l)
      enddo

      return
      end
*************************************************************

